# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from harness_open_api.api_client import ApiClient


class WebhooksApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_webhook(self, registry_ref, **kwargs):  # noqa: E501
        """CreateWebhook  # noqa: E501

        Returns Webhook Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_webhook(registry_ref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param WebhookRequest body: request for create and update webhook
        :return: InlineResponse2012
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_webhook_with_http_info(registry_ref, **kwargs)  # noqa: E501
        else:
            (data) = self.create_webhook_with_http_info(registry_ref, **kwargs)  # noqa: E501
            return data

    def create_webhook_with_http_info(self, registry_ref, **kwargs):  # noqa: E501
        """CreateWebhook  # noqa: E501

        Returns Webhook Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_webhook_with_http_info(registry_ref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param WebhookRequest body: request for create and update webhook
        :return: InlineResponse2012
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['registry_ref', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_webhook" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'registry_ref' is set
        if ('registry_ref' not in params or
                params['registry_ref'] is None):
            raise ValueError("Missing the required parameter `registry_ref` when calling `create_webhook`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'registry_ref' in params:
            path_params['registry_ref'] = params['registry_ref']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['x-api-key']  # noqa: E501

        return self.api_client.call_api(
            '/har/api/v1/registry/{registry_ref}/webhooks', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2012',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_webhook(self, registry_ref, webhook_identifier, **kwargs):  # noqa: E501
        """DeleteWebhook  # noqa: E501

        Delete a Webhook  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_webhook(registry_ref, webhook_identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_webhook_with_http_info(registry_ref, webhook_identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_webhook_with_http_info(registry_ref, webhook_identifier, **kwargs)  # noqa: E501
            return data

    def delete_webhook_with_http_info(self, registry_ref, webhook_identifier, **kwargs):  # noqa: E501
        """DeleteWebhook  # noqa: E501

        Delete a Webhook  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_webhook_with_http_info(registry_ref, webhook_identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['registry_ref', 'webhook_identifier']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_webhook" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'registry_ref' is set
        if ('registry_ref' not in params or
                params['registry_ref'] is None):
            raise ValueError("Missing the required parameter `registry_ref` when calling `delete_webhook`")  # noqa: E501
        # verify the required parameter 'webhook_identifier' is set
        if ('webhook_identifier' not in params or
                params['webhook_identifier'] is None):
            raise ValueError("Missing the required parameter `webhook_identifier` when calling `delete_webhook`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'registry_ref' in params:
            path_params['registry_ref'] = params['registry_ref']  # noqa: E501
        if 'webhook_identifier' in params:
            path_params['webhook_identifier'] = params['webhook_identifier']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['x-api-key']  # noqa: E501

        return self.api_client.call_api(
            '/har/api/v1/registry/{registry_ref}/webhooks/{webhook_identifier}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2006',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_webhook(self, registry_ref, webhook_identifier, **kwargs):  # noqa: E501
        """GetWebhook  # noqa: E501

        Returns Webhook Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_webhook(registry_ref, webhook_identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :return: InlineResponse2012
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_webhook_with_http_info(registry_ref, webhook_identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.get_webhook_with_http_info(registry_ref, webhook_identifier, **kwargs)  # noqa: E501
            return data

    def get_webhook_with_http_info(self, registry_ref, webhook_identifier, **kwargs):  # noqa: E501
        """GetWebhook  # noqa: E501

        Returns Webhook Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_webhook_with_http_info(registry_ref, webhook_identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :return: InlineResponse2012
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['registry_ref', 'webhook_identifier']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_webhook" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'registry_ref' is set
        if ('registry_ref' not in params or
                params['registry_ref'] is None):
            raise ValueError("Missing the required parameter `registry_ref` when calling `get_webhook`")  # noqa: E501
        # verify the required parameter 'webhook_identifier' is set
        if ('webhook_identifier' not in params or
                params['webhook_identifier'] is None):
            raise ValueError("Missing the required parameter `webhook_identifier` when calling `get_webhook`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'registry_ref' in params:
            path_params['registry_ref'] = params['registry_ref']  # noqa: E501
        if 'webhook_identifier' in params:
            path_params['webhook_identifier'] = params['webhook_identifier']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['x-api-key']  # noqa: E501

        return self.api_client.call_api(
            '/har/api/v1/registry/{registry_ref}/webhooks/{webhook_identifier}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2012',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_webhook_execution(self, registry_ref, webhook_identifier, webhook_execution_id, **kwargs):  # noqa: E501
        """GetWebhookExecution  # noqa: E501

        Returns Webhook Execution Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_webhook_execution(registry_ref, webhook_identifier, webhook_execution_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :param str webhook_execution_id: Unique webhook execution identifier. (required)
        :return: InlineResponse20026
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_webhook_execution_with_http_info(registry_ref, webhook_identifier, webhook_execution_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_webhook_execution_with_http_info(registry_ref, webhook_identifier, webhook_execution_id, **kwargs)  # noqa: E501
            return data

    def get_webhook_execution_with_http_info(self, registry_ref, webhook_identifier, webhook_execution_id, **kwargs):  # noqa: E501
        """GetWebhookExecution  # noqa: E501

        Returns Webhook Execution Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_webhook_execution_with_http_info(registry_ref, webhook_identifier, webhook_execution_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :param str webhook_execution_id: Unique webhook execution identifier. (required)
        :return: InlineResponse20026
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['registry_ref', 'webhook_identifier', 'webhook_execution_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_webhook_execution" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'registry_ref' is set
        if ('registry_ref' not in params or
                params['registry_ref'] is None):
            raise ValueError("Missing the required parameter `registry_ref` when calling `get_webhook_execution`")  # noqa: E501
        # verify the required parameter 'webhook_identifier' is set
        if ('webhook_identifier' not in params or
                params['webhook_identifier'] is None):
            raise ValueError("Missing the required parameter `webhook_identifier` when calling `get_webhook_execution`")  # noqa: E501
        # verify the required parameter 'webhook_execution_id' is set
        if ('webhook_execution_id' not in params or
                params['webhook_execution_id'] is None):
            raise ValueError("Missing the required parameter `webhook_execution_id` when calling `get_webhook_execution`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'registry_ref' in params:
            path_params['registry_ref'] = params['registry_ref']  # noqa: E501
        if 'webhook_identifier' in params:
            path_params['webhook_identifier'] = params['webhook_identifier']  # noqa: E501
        if 'webhook_execution_id' in params:
            path_params['webhook_execution_id'] = params['webhook_execution_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['x-api-key']  # noqa: E501

        return self.api_client.call_api(
            '/har/api/v1/registry/{registry_ref}/webhooks/{webhook_identifier}/executions/{webhook_execution_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20026',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_webhook_executions(self, registry_ref, webhook_identifier, **kwargs):  # noqa: E501
        """ListWebhookExecutions  # noqa: E501

        Returns Webhook Execution Details List  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_webhook_executions(registry_ref, webhook_identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :param int page: Current page number
        :param int size: Number of items per page
        :return: InlineResponse20025
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_webhook_executions_with_http_info(registry_ref, webhook_identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.list_webhook_executions_with_http_info(registry_ref, webhook_identifier, **kwargs)  # noqa: E501
            return data

    def list_webhook_executions_with_http_info(self, registry_ref, webhook_identifier, **kwargs):  # noqa: E501
        """ListWebhookExecutions  # noqa: E501

        Returns Webhook Execution Details List  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_webhook_executions_with_http_info(registry_ref, webhook_identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :param int page: Current page number
        :param int size: Number of items per page
        :return: InlineResponse20025
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['registry_ref', 'webhook_identifier', 'page', 'size']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_webhook_executions" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'registry_ref' is set
        if ('registry_ref' not in params or
                params['registry_ref'] is None):
            raise ValueError("Missing the required parameter `registry_ref` when calling `list_webhook_executions`")  # noqa: E501
        # verify the required parameter 'webhook_identifier' is set
        if ('webhook_identifier' not in params or
                params['webhook_identifier'] is None):
            raise ValueError("Missing the required parameter `webhook_identifier` when calling `list_webhook_executions`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'registry_ref' in params:
            path_params['registry_ref'] = params['registry_ref']  # noqa: E501
        if 'webhook_identifier' in params:
            path_params['webhook_identifier'] = params['webhook_identifier']  # noqa: E501

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['x-api-key']  # noqa: E501

        return self.api_client.call_api(
            '/har/api/v1/registry/{registry_ref}/webhooks/{webhook_identifier}/executions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20025',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_webhooks(self, registry_ref, **kwargs):  # noqa: E501
        """ListWebhooks  # noqa: E501

        Returns List of Webhook Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_webhooks(registry_ref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param int page: Current page number
        :param int size: Number of items per page
        :param str sort_order: sortOrder
        :param str sort_field: sortField
        :param str search_term: search Term.
        :return: InlineResponse20024
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_webhooks_with_http_info(registry_ref, **kwargs)  # noqa: E501
        else:
            (data) = self.list_webhooks_with_http_info(registry_ref, **kwargs)  # noqa: E501
            return data

    def list_webhooks_with_http_info(self, registry_ref, **kwargs):  # noqa: E501
        """ListWebhooks  # noqa: E501

        Returns List of Webhook Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_webhooks_with_http_info(registry_ref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param int page: Current page number
        :param int size: Number of items per page
        :param str sort_order: sortOrder
        :param str sort_field: sortField
        :param str search_term: search Term.
        :return: InlineResponse20024
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['registry_ref', 'page', 'size', 'sort_order', 'sort_field', 'search_term']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_webhooks" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'registry_ref' is set
        if ('registry_ref' not in params or
                params['registry_ref'] is None):
            raise ValueError("Missing the required parameter `registry_ref` when calling `list_webhooks`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'registry_ref' in params:
            path_params['registry_ref'] = params['registry_ref']  # noqa: E501

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort_order' in params:
            query_params.append(('sort_order', params['sort_order']))  # noqa: E501
        if 'sort_field' in params:
            query_params.append(('sort_field', params['sort_field']))  # noqa: E501
        if 'search_term' in params:
            query_params.append(('search_term', params['search_term']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['x-api-key']  # noqa: E501

        return self.api_client.call_api(
            '/har/api/v1/registry/{registry_ref}/webhooks', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20024',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def re_trigger_webhook_execution(self, registry_ref, webhook_identifier, webhook_execution_id, **kwargs):  # noqa: E501
        """ReTriggerWebhookExecution  # noqa: E501

        Retrigger Webhook Execution  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.re_trigger_webhook_execution(registry_ref, webhook_identifier, webhook_execution_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :param str webhook_execution_id: Unique webhook execution identifier. (required)
        :return: InlineResponse20026
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.re_trigger_webhook_execution_with_http_info(registry_ref, webhook_identifier, webhook_execution_id, **kwargs)  # noqa: E501
        else:
            (data) = self.re_trigger_webhook_execution_with_http_info(registry_ref, webhook_identifier, webhook_execution_id, **kwargs)  # noqa: E501
            return data

    def re_trigger_webhook_execution_with_http_info(self, registry_ref, webhook_identifier, webhook_execution_id, **kwargs):  # noqa: E501
        """ReTriggerWebhookExecution  # noqa: E501

        Retrigger Webhook Execution  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.re_trigger_webhook_execution_with_http_info(registry_ref, webhook_identifier, webhook_execution_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :param str webhook_execution_id: Unique webhook execution identifier. (required)
        :return: InlineResponse20026
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['registry_ref', 'webhook_identifier', 'webhook_execution_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method re_trigger_webhook_execution" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'registry_ref' is set
        if ('registry_ref' not in params or
                params['registry_ref'] is None):
            raise ValueError("Missing the required parameter `registry_ref` when calling `re_trigger_webhook_execution`")  # noqa: E501
        # verify the required parameter 'webhook_identifier' is set
        if ('webhook_identifier' not in params or
                params['webhook_identifier'] is None):
            raise ValueError("Missing the required parameter `webhook_identifier` when calling `re_trigger_webhook_execution`")  # noqa: E501
        # verify the required parameter 'webhook_execution_id' is set
        if ('webhook_execution_id' not in params or
                params['webhook_execution_id'] is None):
            raise ValueError("Missing the required parameter `webhook_execution_id` when calling `re_trigger_webhook_execution`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'registry_ref' in params:
            path_params['registry_ref'] = params['registry_ref']  # noqa: E501
        if 'webhook_identifier' in params:
            path_params['webhook_identifier'] = params['webhook_identifier']  # noqa: E501
        if 'webhook_execution_id' in params:
            path_params['webhook_execution_id'] = params['webhook_execution_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['x-api-key']  # noqa: E501

        return self.api_client.call_api(
            '/har/api/v1/registry/{registry_ref}/webhooks/{webhook_identifier}/executions/{webhook_execution_id}/retrigger', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20026',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_webhook(self, registry_ref, webhook_identifier, **kwargs):  # noqa: E501
        """UpdateWebhook  # noqa: E501

        Returns Webhook Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_webhook(registry_ref, webhook_identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :param WebhookRequest body: request for create and update webhook
        :return: InlineResponse2012
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_webhook_with_http_info(registry_ref, webhook_identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.update_webhook_with_http_info(registry_ref, webhook_identifier, **kwargs)  # noqa: E501
            return data

    def update_webhook_with_http_info(self, registry_ref, webhook_identifier, **kwargs):  # noqa: E501
        """UpdateWebhook  # noqa: E501

        Returns Webhook Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_webhook_with_http_info(registry_ref, webhook_identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str registry_ref: Unique registry path. (required)
        :param str webhook_identifier: Unique webhook identifier. (required)
        :param WebhookRequest body: request for create and update webhook
        :return: InlineResponse2012
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['registry_ref', 'webhook_identifier', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_webhook" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'registry_ref' is set
        if ('registry_ref' not in params or
                params['registry_ref'] is None):
            raise ValueError("Missing the required parameter `registry_ref` when calling `update_webhook`")  # noqa: E501
        # verify the required parameter 'webhook_identifier' is set
        if ('webhook_identifier' not in params or
                params['webhook_identifier'] is None):
            raise ValueError("Missing the required parameter `webhook_identifier` when calling `update_webhook`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'registry_ref' in params:
            path_params['registry_ref'] = params['registry_ref']  # noqa: E501
        if 'webhook_identifier' in params:
            path_params['webhook_identifier'] = params['webhook_identifier']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['x-api-key']  # noqa: E501

        return self.api_client.call_api(
            '/har/api/v1/registry/{registry_ref}/webhooks/{webhook_identifier}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2012',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
