# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class EncryptionConfig(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'default': 'bool',
        'encryption_service_url': 'str',
        'encryption_type': 'str',
        'global_kms': 'bool',
        'name': 'str',
        'num_of_encrypted_value': 'int',
        'type': 'str',
        'uuid': 'str',
        'validation_criteria': 'str'
    }

    attribute_map = {
        'account_id': 'accountId',
        'default': 'default',
        'encryption_service_url': 'encryptionServiceUrl',
        'encryption_type': 'encryptionType',
        'global_kms': 'globalKms',
        'name': 'name',
        'num_of_encrypted_value': 'numOfEncryptedValue',
        'type': 'type',
        'uuid': 'uuid',
        'validation_criteria': 'validationCriteria'
    }

    def __init__(self, account_id=None, default=None, encryption_service_url=None, encryption_type=None, global_kms=None, name=None, num_of_encrypted_value=None, type=None, uuid=None, validation_criteria=None):  # noqa: E501
        """EncryptionConfig - a model defined in Swagger"""  # noqa: E501
        self._account_id = None
        self._default = None
        self._encryption_service_url = None
        self._encryption_type = None
        self._global_kms = None
        self._name = None
        self._num_of_encrypted_value = None
        self._type = None
        self._uuid = None
        self._validation_criteria = None
        self.discriminator = None
        if account_id is not None:
            self.account_id = account_id
        if default is not None:
            self.default = default
        if encryption_service_url is not None:
            self.encryption_service_url = encryption_service_url
        if encryption_type is not None:
            self.encryption_type = encryption_type
        if global_kms is not None:
            self.global_kms = global_kms
        if name is not None:
            self.name = name
        if num_of_encrypted_value is not None:
            self.num_of_encrypted_value = num_of_encrypted_value
        if type is not None:
            self.type = type
        if uuid is not None:
            self.uuid = uuid
        if validation_criteria is not None:
            self.validation_criteria = validation_criteria

    @property
    def account_id(self):
        """Gets the account_id of this EncryptionConfig.  # noqa: E501


        :return: The account_id of this EncryptionConfig.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this EncryptionConfig.


        :param account_id: The account_id of this EncryptionConfig.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def default(self):
        """Gets the default of this EncryptionConfig.  # noqa: E501


        :return: The default of this EncryptionConfig.  # noqa: E501
        :rtype: bool
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this EncryptionConfig.


        :param default: The default of this EncryptionConfig.  # noqa: E501
        :type: bool
        """

        self._default = default

    @property
    def encryption_service_url(self):
        """Gets the encryption_service_url of this EncryptionConfig.  # noqa: E501


        :return: The encryption_service_url of this EncryptionConfig.  # noqa: E501
        :rtype: str
        """
        return self._encryption_service_url

    @encryption_service_url.setter
    def encryption_service_url(self, encryption_service_url):
        """Sets the encryption_service_url of this EncryptionConfig.


        :param encryption_service_url: The encryption_service_url of this EncryptionConfig.  # noqa: E501
        :type: str
        """

        self._encryption_service_url = encryption_service_url

    @property
    def encryption_type(self):
        """Gets the encryption_type of this EncryptionConfig.  # noqa: E501


        :return: The encryption_type of this EncryptionConfig.  # noqa: E501
        :rtype: str
        """
        return self._encryption_type

    @encryption_type.setter
    def encryption_type(self, encryption_type):
        """Sets the encryption_type of this EncryptionConfig.


        :param encryption_type: The encryption_type of this EncryptionConfig.  # noqa: E501
        :type: str
        """
        allowed_values = ["LOCAL", "KMS", "GCP_KMS", "AWS_SECRETS_MANAGER", "AZURE_VAULT", "VAULT", "GCP_SECRETS_MANAGER", "CUSTOM", "VAULT_SSH", "CUSTOM_NG"]  # noqa: E501
        if encryption_type not in allowed_values:
            raise ValueError(
                "Invalid value for `encryption_type` ({0}), must be one of {1}"  # noqa: E501
                .format(encryption_type, allowed_values)
            )

        self._encryption_type = encryption_type

    @property
    def global_kms(self):
        """Gets the global_kms of this EncryptionConfig.  # noqa: E501


        :return: The global_kms of this EncryptionConfig.  # noqa: E501
        :rtype: bool
        """
        return self._global_kms

    @global_kms.setter
    def global_kms(self, global_kms):
        """Sets the global_kms of this EncryptionConfig.


        :param global_kms: The global_kms of this EncryptionConfig.  # noqa: E501
        :type: bool
        """

        self._global_kms = global_kms

    @property
    def name(self):
        """Gets the name of this EncryptionConfig.  # noqa: E501


        :return: The name of this EncryptionConfig.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EncryptionConfig.


        :param name: The name of this EncryptionConfig.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def num_of_encrypted_value(self):
        """Gets the num_of_encrypted_value of this EncryptionConfig.  # noqa: E501


        :return: The num_of_encrypted_value of this EncryptionConfig.  # noqa: E501
        :rtype: int
        """
        return self._num_of_encrypted_value

    @num_of_encrypted_value.setter
    def num_of_encrypted_value(self, num_of_encrypted_value):
        """Sets the num_of_encrypted_value of this EncryptionConfig.


        :param num_of_encrypted_value: The num_of_encrypted_value of this EncryptionConfig.  # noqa: E501
        :type: int
        """

        self._num_of_encrypted_value = num_of_encrypted_value

    @property
    def type(self):
        """Gets the type of this EncryptionConfig.  # noqa: E501


        :return: The type of this EncryptionConfig.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this EncryptionConfig.


        :param type: The type of this EncryptionConfig.  # noqa: E501
        :type: str
        """
        allowed_values = ["KMS", "VAULT", "CUSTOM", "SSH"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def uuid(self):
        """Gets the uuid of this EncryptionConfig.  # noqa: E501


        :return: The uuid of this EncryptionConfig.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this EncryptionConfig.


        :param uuid: The uuid of this EncryptionConfig.  # noqa: E501
        :type: str
        """

        self._uuid = uuid

    @property
    def validation_criteria(self):
        """Gets the validation_criteria of this EncryptionConfig.  # noqa: E501


        :return: The validation_criteria of this EncryptionConfig.  # noqa: E501
        :rtype: str
        """
        return self._validation_criteria

    @validation_criteria.setter
    def validation_criteria(self, validation_criteria):
        """Sets the validation_criteria of this EncryptionConfig.


        :param validation_criteria: The validation_criteria of this EncryptionConfig.  # noqa: E501
        :type: str
        """

        self._validation_criteria = validation_criteria

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EncryptionConfig, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EncryptionConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
