# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GovernanceJobEnqueueDTO(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'execution_type': 'str',
        'gov_cloud_connector': 'bool',
        'is_dry_run': 'bool',
        'is_gov_cloud_connector': 'bool',
        'is_multi_policy_rule': 'bool',
        'is_ootb': 'bool',
        'multi_policy_rule': 'bool',
        'policy': 'str',
        'rule_cloud_provider_type': 'str',
        'rule_enforcement_id': 'str',
        'rule_enforcement_recommendation_id': 'str',
        'rule_execution_id': 'str',
        'rule_id': 'str',
        'sub_rule_policy_details': 'list[SubRulePolicyDetails]',
        'target_account_details': 'RecommendationAdhocDTO',
        'target_region': 'str'
    }

    attribute_map = {
        'execution_type': 'executionType',
        'gov_cloud_connector': 'govCloudConnector',
        'is_dry_run': 'isDryRun',
        'is_gov_cloud_connector': 'isGovCloudConnector',
        'is_multi_policy_rule': 'isMultiPolicyRule',
        'is_ootb': 'isOOTB',
        'multi_policy_rule': 'multiPolicyRule',
        'policy': 'policy',
        'rule_cloud_provider_type': 'ruleCloudProviderType',
        'rule_enforcement_id': 'ruleEnforcementId',
        'rule_enforcement_recommendation_id': 'ruleEnforcementRecommendationId',
        'rule_execution_id': 'ruleExecutionId',
        'rule_id': 'ruleId',
        'sub_rule_policy_details': 'subRulePolicyDetails',
        'target_account_details': 'targetAccountDetails',
        'target_region': 'targetRegion'
    }

    def __init__(self, execution_type=None, gov_cloud_connector=None, is_dry_run=None, is_gov_cloud_connector=None, is_multi_policy_rule=None, is_ootb=None, multi_policy_rule=None, policy=None, rule_cloud_provider_type=None, rule_enforcement_id=None, rule_enforcement_recommendation_id=None, rule_execution_id=None, rule_id=None, sub_rule_policy_details=None, target_account_details=None, target_region=None):  # noqa: E501
        """GovernanceJobEnqueueDTO - a model defined in Swagger"""  # noqa: E501
        self._execution_type = None
        self._gov_cloud_connector = None
        self._is_dry_run = None
        self._is_gov_cloud_connector = None
        self._is_multi_policy_rule = None
        self._is_ootb = None
        self._multi_policy_rule = None
        self._policy = None
        self._rule_cloud_provider_type = None
        self._rule_enforcement_id = None
        self._rule_enforcement_recommendation_id = None
        self._rule_execution_id = None
        self._rule_id = None
        self._sub_rule_policy_details = None
        self._target_account_details = None
        self._target_region = None
        self.discriminator = None
        if execution_type is not None:
            self.execution_type = execution_type
        if gov_cloud_connector is not None:
            self.gov_cloud_connector = gov_cloud_connector
        if is_dry_run is not None:
            self.is_dry_run = is_dry_run
        if is_gov_cloud_connector is not None:
            self.is_gov_cloud_connector = is_gov_cloud_connector
        if is_multi_policy_rule is not None:
            self.is_multi_policy_rule = is_multi_policy_rule
        if is_ootb is not None:
            self.is_ootb = is_ootb
        if multi_policy_rule is not None:
            self.multi_policy_rule = multi_policy_rule
        if policy is not None:
            self.policy = policy
        if rule_cloud_provider_type is not None:
            self.rule_cloud_provider_type = rule_cloud_provider_type
        if rule_enforcement_id is not None:
            self.rule_enforcement_id = rule_enforcement_id
        if rule_enforcement_recommendation_id is not None:
            self.rule_enforcement_recommendation_id = rule_enforcement_recommendation_id
        if rule_execution_id is not None:
            self.rule_execution_id = rule_execution_id
        if rule_id is not None:
            self.rule_id = rule_id
        if sub_rule_policy_details is not None:
            self.sub_rule_policy_details = sub_rule_policy_details
        if target_account_details is not None:
            self.target_account_details = target_account_details
        if target_region is not None:
            self.target_region = target_region

    @property
    def execution_type(self):
        """Gets the execution_type of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The execution_type of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: str
        """
        return self._execution_type

    @execution_type.setter
    def execution_type(self, execution_type):
        """Sets the execution_type of this GovernanceJobEnqueueDTO.


        :param execution_type: The execution_type of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: str
        """
        allowed_values = ["INTERNAL", "EXTERNAL"]  # noqa: E501
        if execution_type not in allowed_values:
            raise ValueError(
                "Invalid value for `execution_type` ({0}), must be one of {1}"  # noqa: E501
                .format(execution_type, allowed_values)
            )

        self._execution_type = execution_type

    @property
    def gov_cloud_connector(self):
        """Gets the gov_cloud_connector of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The gov_cloud_connector of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: bool
        """
        return self._gov_cloud_connector

    @gov_cloud_connector.setter
    def gov_cloud_connector(self, gov_cloud_connector):
        """Sets the gov_cloud_connector of this GovernanceJobEnqueueDTO.


        :param gov_cloud_connector: The gov_cloud_connector of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: bool
        """

        self._gov_cloud_connector = gov_cloud_connector

    @property
    def is_dry_run(self):
        """Gets the is_dry_run of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The is_dry_run of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: bool
        """
        return self._is_dry_run

    @is_dry_run.setter
    def is_dry_run(self, is_dry_run):
        """Sets the is_dry_run of this GovernanceJobEnqueueDTO.


        :param is_dry_run: The is_dry_run of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: bool
        """

        self._is_dry_run = is_dry_run

    @property
    def is_gov_cloud_connector(self):
        """Gets the is_gov_cloud_connector of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The is_gov_cloud_connector of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: bool
        """
        return self._is_gov_cloud_connector

    @is_gov_cloud_connector.setter
    def is_gov_cloud_connector(self, is_gov_cloud_connector):
        """Sets the is_gov_cloud_connector of this GovernanceJobEnqueueDTO.


        :param is_gov_cloud_connector: The is_gov_cloud_connector of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: bool
        """

        self._is_gov_cloud_connector = is_gov_cloud_connector

    @property
    def is_multi_policy_rule(self):
        """Gets the is_multi_policy_rule of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The is_multi_policy_rule of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: bool
        """
        return self._is_multi_policy_rule

    @is_multi_policy_rule.setter
    def is_multi_policy_rule(self, is_multi_policy_rule):
        """Sets the is_multi_policy_rule of this GovernanceJobEnqueueDTO.


        :param is_multi_policy_rule: The is_multi_policy_rule of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: bool
        """

        self._is_multi_policy_rule = is_multi_policy_rule

    @property
    def is_ootb(self):
        """Gets the is_ootb of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The is_ootb of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: bool
        """
        return self._is_ootb

    @is_ootb.setter
    def is_ootb(self, is_ootb):
        """Sets the is_ootb of this GovernanceJobEnqueueDTO.


        :param is_ootb: The is_ootb of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: bool
        """

        self._is_ootb = is_ootb

    @property
    def multi_policy_rule(self):
        """Gets the multi_policy_rule of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The multi_policy_rule of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: bool
        """
        return self._multi_policy_rule

    @multi_policy_rule.setter
    def multi_policy_rule(self, multi_policy_rule):
        """Sets the multi_policy_rule of this GovernanceJobEnqueueDTO.


        :param multi_policy_rule: The multi_policy_rule of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: bool
        """

        self._multi_policy_rule = multi_policy_rule

    @property
    def policy(self):
        """Gets the policy of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The policy of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: str
        """
        return self._policy

    @policy.setter
    def policy(self, policy):
        """Sets the policy of this GovernanceJobEnqueueDTO.


        :param policy: The policy of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: str
        """

        self._policy = policy

    @property
    def rule_cloud_provider_type(self):
        """Gets the rule_cloud_provider_type of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The rule_cloud_provider_type of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: str
        """
        return self._rule_cloud_provider_type

    @rule_cloud_provider_type.setter
    def rule_cloud_provider_type(self, rule_cloud_provider_type):
        """Sets the rule_cloud_provider_type of this GovernanceJobEnqueueDTO.


        :param rule_cloud_provider_type: The rule_cloud_provider_type of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: str
        """
        allowed_values = ["AWS", "AZURE", "GCP"]  # noqa: E501
        if rule_cloud_provider_type not in allowed_values:
            raise ValueError(
                "Invalid value for `rule_cloud_provider_type` ({0}), must be one of {1}"  # noqa: E501
                .format(rule_cloud_provider_type, allowed_values)
            )

        self._rule_cloud_provider_type = rule_cloud_provider_type

    @property
    def rule_enforcement_id(self):
        """Gets the rule_enforcement_id of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The rule_enforcement_id of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: str
        """
        return self._rule_enforcement_id

    @rule_enforcement_id.setter
    def rule_enforcement_id(self, rule_enforcement_id):
        """Sets the rule_enforcement_id of this GovernanceJobEnqueueDTO.


        :param rule_enforcement_id: The rule_enforcement_id of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: str
        """

        self._rule_enforcement_id = rule_enforcement_id

    @property
    def rule_enforcement_recommendation_id(self):
        """Gets the rule_enforcement_recommendation_id of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The rule_enforcement_recommendation_id of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: str
        """
        return self._rule_enforcement_recommendation_id

    @rule_enforcement_recommendation_id.setter
    def rule_enforcement_recommendation_id(self, rule_enforcement_recommendation_id):
        """Sets the rule_enforcement_recommendation_id of this GovernanceJobEnqueueDTO.


        :param rule_enforcement_recommendation_id: The rule_enforcement_recommendation_id of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: str
        """

        self._rule_enforcement_recommendation_id = rule_enforcement_recommendation_id

    @property
    def rule_execution_id(self):
        """Gets the rule_execution_id of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The rule_execution_id of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: str
        """
        return self._rule_execution_id

    @rule_execution_id.setter
    def rule_execution_id(self, rule_execution_id):
        """Sets the rule_execution_id of this GovernanceJobEnqueueDTO.


        :param rule_execution_id: The rule_execution_id of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: str
        """

        self._rule_execution_id = rule_execution_id

    @property
    def rule_id(self):
        """Gets the rule_id of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The rule_id of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: str
        """
        return self._rule_id

    @rule_id.setter
    def rule_id(self, rule_id):
        """Sets the rule_id of this GovernanceJobEnqueueDTO.


        :param rule_id: The rule_id of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: str
        """

        self._rule_id = rule_id

    @property
    def sub_rule_policy_details(self):
        """Gets the sub_rule_policy_details of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The sub_rule_policy_details of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: list[SubRulePolicyDetails]
        """
        return self._sub_rule_policy_details

    @sub_rule_policy_details.setter
    def sub_rule_policy_details(self, sub_rule_policy_details):
        """Sets the sub_rule_policy_details of this GovernanceJobEnqueueDTO.


        :param sub_rule_policy_details: The sub_rule_policy_details of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: list[SubRulePolicyDetails]
        """

        self._sub_rule_policy_details = sub_rule_policy_details

    @property
    def target_account_details(self):
        """Gets the target_account_details of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The target_account_details of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: RecommendationAdhocDTO
        """
        return self._target_account_details

    @target_account_details.setter
    def target_account_details(self, target_account_details):
        """Sets the target_account_details of this GovernanceJobEnqueueDTO.


        :param target_account_details: The target_account_details of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: RecommendationAdhocDTO
        """

        self._target_account_details = target_account_details

    @property
    def target_region(self):
        """Gets the target_region of this GovernanceJobEnqueueDTO.  # noqa: E501


        :return: The target_region of this GovernanceJobEnqueueDTO.  # noqa: E501
        :rtype: str
        """
        return self._target_region

    @target_region.setter
    def target_region(self, target_region):
        """Sets the target_region of this GovernanceJobEnqueueDTO.


        :param target_region: The target_region of this GovernanceJobEnqueueDTO.  # noqa: E501
        :type: str
        """

        self._target_region = target_region

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GovernanceJobEnqueueDTO, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GovernanceJobEnqueueDTO):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
