# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from harness_open_api.models.approval_instance_details_dto import ApprovalInstanceDetailsDTO  # noqa: F401,E501

class HarnessApprovalInstanceDetails(ApprovalInstanceDetailsDTO):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'approval_activities': 'list[HarnessApprovalActivity]',
        'approval_message': 'str',
        'approver_inputs': 'list[ApproverInputInfo]',
        'approvers': 'Approvers',
        'auto_approval_params': 'AutoApproval',
        'auto_reject_enabled': 'bool',
        'include_pipeline_execution_history': 'bool',
        'is_auto_reject_enabled': 'bool',
        'validated_approval_service_accounts': 'list[ApprovalServiceAccount]',
        'validated_approval_user_groups': 'list[ApprovalUserGroup]'
    }
    if hasattr(ApprovalInstanceDetailsDTO, "swagger_types"):
        swagger_types.update(ApprovalInstanceDetailsDTO.swagger_types)

    attribute_map = {
        'approval_activities': 'approvalActivities',
        'approval_message': 'approvalMessage',
        'approver_inputs': 'approverInputs',
        'approvers': 'approvers',
        'auto_approval_params': 'autoApprovalParams',
        'auto_reject_enabled': 'autoRejectEnabled',
        'include_pipeline_execution_history': 'includePipelineExecutionHistory',
        'is_auto_reject_enabled': 'isAutoRejectEnabled',
        'validated_approval_service_accounts': 'validatedApprovalServiceAccounts',
        'validated_approval_user_groups': 'validatedApprovalUserGroups'
    }
    if hasattr(ApprovalInstanceDetailsDTO, "attribute_map"):
        attribute_map.update(ApprovalInstanceDetailsDTO.attribute_map)

    def __init__(self, approval_activities=None, approval_message=None, approver_inputs=None, approvers=None, auto_approval_params=None, auto_reject_enabled=None, include_pipeline_execution_history=None, is_auto_reject_enabled=None, validated_approval_service_accounts=None, validated_approval_user_groups=None, *args, **kwargs):  # noqa: E501
        """HarnessApprovalInstanceDetails - a model defined in Swagger"""  # noqa: E501
        self._approval_activities = None
        self._approval_message = None
        self._approver_inputs = None
        self._approvers = None
        self._auto_approval_params = None
        self._auto_reject_enabled = None
        self._include_pipeline_execution_history = None
        self._is_auto_reject_enabled = None
        self._validated_approval_service_accounts = None
        self._validated_approval_user_groups = None
        self.discriminator = None
        if approval_activities is not None:
            self.approval_activities = approval_activities
        if approval_message is not None:
            self.approval_message = approval_message
        if approver_inputs is not None:
            self.approver_inputs = approver_inputs
        self.approvers = approvers
        if auto_approval_params is not None:
            self.auto_approval_params = auto_approval_params
        if auto_reject_enabled is not None:
            self.auto_reject_enabled = auto_reject_enabled
        if include_pipeline_execution_history is not None:
            self.include_pipeline_execution_history = include_pipeline_execution_history
        if is_auto_reject_enabled is not None:
            self.is_auto_reject_enabled = is_auto_reject_enabled
        if validated_approval_service_accounts is not None:
            self.validated_approval_service_accounts = validated_approval_service_accounts
        if validated_approval_user_groups is not None:
            self.validated_approval_user_groups = validated_approval_user_groups
        ApprovalInstanceDetailsDTO.__init__(self, *args, **kwargs)

    @property
    def approval_activities(self):
        """Gets the approval_activities of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The approval_activities of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: list[HarnessApprovalActivity]
        """
        return self._approval_activities

    @approval_activities.setter
    def approval_activities(self, approval_activities):
        """Sets the approval_activities of this HarnessApprovalInstanceDetails.


        :param approval_activities: The approval_activities of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: list[HarnessApprovalActivity]
        """

        self._approval_activities = approval_activities

    @property
    def approval_message(self):
        """Gets the approval_message of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The approval_message of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: str
        """
        return self._approval_message

    @approval_message.setter
    def approval_message(self, approval_message):
        """Sets the approval_message of this HarnessApprovalInstanceDetails.


        :param approval_message: The approval_message of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: str
        """

        self._approval_message = approval_message

    @property
    def approver_inputs(self):
        """Gets the approver_inputs of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The approver_inputs of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: list[ApproverInputInfo]
        """
        return self._approver_inputs

    @approver_inputs.setter
    def approver_inputs(self, approver_inputs):
        """Sets the approver_inputs of this HarnessApprovalInstanceDetails.


        :param approver_inputs: The approver_inputs of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: list[ApproverInputInfo]
        """

        self._approver_inputs = approver_inputs

    @property
    def approvers(self):
        """Gets the approvers of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The approvers of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: Approvers
        """
        return self._approvers

    @approvers.setter
    def approvers(self, approvers):
        """Sets the approvers of this HarnessApprovalInstanceDetails.


        :param approvers: The approvers of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: Approvers
        """
        if approvers is None:
            raise ValueError("Invalid value for `approvers`, must not be `None`")  # noqa: E501

        self._approvers = approvers

    @property
    def auto_approval_params(self):
        """Gets the auto_approval_params of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The auto_approval_params of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: AutoApproval
        """
        return self._auto_approval_params

    @auto_approval_params.setter
    def auto_approval_params(self, auto_approval_params):
        """Sets the auto_approval_params of this HarnessApprovalInstanceDetails.


        :param auto_approval_params: The auto_approval_params of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: AutoApproval
        """

        self._auto_approval_params = auto_approval_params

    @property
    def auto_reject_enabled(self):
        """Gets the auto_reject_enabled of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The auto_reject_enabled of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: bool
        """
        return self._auto_reject_enabled

    @auto_reject_enabled.setter
    def auto_reject_enabled(self, auto_reject_enabled):
        """Sets the auto_reject_enabled of this HarnessApprovalInstanceDetails.


        :param auto_reject_enabled: The auto_reject_enabled of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: bool
        """

        self._auto_reject_enabled = auto_reject_enabled

    @property
    def include_pipeline_execution_history(self):
        """Gets the include_pipeline_execution_history of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The include_pipeline_execution_history of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: bool
        """
        return self._include_pipeline_execution_history

    @include_pipeline_execution_history.setter
    def include_pipeline_execution_history(self, include_pipeline_execution_history):
        """Sets the include_pipeline_execution_history of this HarnessApprovalInstanceDetails.


        :param include_pipeline_execution_history: The include_pipeline_execution_history of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: bool
        """

        self._include_pipeline_execution_history = include_pipeline_execution_history

    @property
    def is_auto_reject_enabled(self):
        """Gets the is_auto_reject_enabled of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The is_auto_reject_enabled of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: bool
        """
        return self._is_auto_reject_enabled

    @is_auto_reject_enabled.setter
    def is_auto_reject_enabled(self, is_auto_reject_enabled):
        """Sets the is_auto_reject_enabled of this HarnessApprovalInstanceDetails.


        :param is_auto_reject_enabled: The is_auto_reject_enabled of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: bool
        """

        self._is_auto_reject_enabled = is_auto_reject_enabled

    @property
    def validated_approval_service_accounts(self):
        """Gets the validated_approval_service_accounts of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The validated_approval_service_accounts of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: list[ApprovalServiceAccount]
        """
        return self._validated_approval_service_accounts

    @validated_approval_service_accounts.setter
    def validated_approval_service_accounts(self, validated_approval_service_accounts):
        """Sets the validated_approval_service_accounts of this HarnessApprovalInstanceDetails.


        :param validated_approval_service_accounts: The validated_approval_service_accounts of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: list[ApprovalServiceAccount]
        """

        self._validated_approval_service_accounts = validated_approval_service_accounts

    @property
    def validated_approval_user_groups(self):
        """Gets the validated_approval_user_groups of this HarnessApprovalInstanceDetails.  # noqa: E501


        :return: The validated_approval_user_groups of this HarnessApprovalInstanceDetails.  # noqa: E501
        :rtype: list[ApprovalUserGroup]
        """
        return self._validated_approval_user_groups

    @validated_approval_user_groups.setter
    def validated_approval_user_groups(self, validated_approval_user_groups):
        """Sets the validated_approval_user_groups of this HarnessApprovalInstanceDetails.


        :param validated_approval_user_groups: The validated_approval_user_groups of this HarnessApprovalInstanceDetails.  # noqa: E501
        :type: list[ApprovalUserGroup]
        """

        self._validated_approval_user_groups = validated_approval_user_groups

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HarnessApprovalInstanceDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HarnessApprovalInstanceDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
