# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InputSetResponseBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'connector_ref': 'str',
        'created': 'int',
        'description': 'str',
        'error_details': 'InputSetErrorDetails',
        'git_details': 'GitDetails',
        'identifier': 'str',
        'input_set_yaml': 'str',
        'name': 'str',
        'org': 'str',
        'pipeline': 'str',
        'project': 'str',
        'store_type': 'str',
        'tags': 'dict(str, str)',
        'updated': 'int'
    }

    attribute_map = {
        'connector_ref': 'connector_ref',
        'created': 'created',
        'description': 'description',
        'error_details': 'error_details',
        'git_details': 'git_details',
        'identifier': 'identifier',
        'input_set_yaml': 'input_set_yaml',
        'name': 'name',
        'org': 'org',
        'pipeline': 'pipeline',
        'project': 'project',
        'store_type': 'store_type',
        'tags': 'tags',
        'updated': 'updated'
    }

    def __init__(self, connector_ref=None, created=None, description=None, error_details=None, git_details=None, identifier=None, input_set_yaml=None, name=None, org=None, pipeline=None, project=None, store_type=None, tags=None, updated=None):  # noqa: E501
        """InputSetResponseBody - a model defined in Swagger"""  # noqa: E501
        self._connector_ref = None
        self._created = None
        self._description = None
        self._error_details = None
        self._git_details = None
        self._identifier = None
        self._input_set_yaml = None
        self._name = None
        self._org = None
        self._pipeline = None
        self._project = None
        self._store_type = None
        self._tags = None
        self._updated = None
        self.discriminator = None
        if connector_ref is not None:
            self.connector_ref = connector_ref
        if created is not None:
            self.created = created
        if description is not None:
            self.description = description
        if error_details is not None:
            self.error_details = error_details
        if git_details is not None:
            self.git_details = git_details
        if identifier is not None:
            self.identifier = identifier
        if input_set_yaml is not None:
            self.input_set_yaml = input_set_yaml
        if name is not None:
            self.name = name
        if org is not None:
            self.org = org
        if pipeline is not None:
            self.pipeline = pipeline
        if project is not None:
            self.project = project
        if store_type is not None:
            self.store_type = store_type
        if tags is not None:
            self.tags = tags
        if updated is not None:
            self.updated = updated

    @property
    def connector_ref(self):
        """Gets the connector_ref of this InputSetResponseBody.  # noqa: E501

        Identifier of the Harness Connector used for CRUD operations on the Entity (for Git Experience).  # noqa: E501

        :return: The connector_ref of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._connector_ref

    @connector_ref.setter
    def connector_ref(self, connector_ref):
        """Sets the connector_ref of this InputSetResponseBody.

        Identifier of the Harness Connector used for CRUD operations on the Entity (for Git Experience).  # noqa: E501

        :param connector_ref: The connector_ref of this InputSetResponseBody.  # noqa: E501
        :type: str
        """

        self._connector_ref = connector_ref

    @property
    def created(self):
        """Gets the created of this InputSetResponseBody.  # noqa: E501

        Creation timestamp for Input Set.  # noqa: E501

        :return: The created of this InputSetResponseBody.  # noqa: E501
        :rtype: int
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this InputSetResponseBody.

        Creation timestamp for Input Set.  # noqa: E501

        :param created: The created of this InputSetResponseBody.  # noqa: E501
        :type: int
        """

        self._created = created

    @property
    def description(self):
        """Gets the description of this InputSetResponseBody.  # noqa: E501

        Input Set description  # noqa: E501

        :return: The description of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InputSetResponseBody.

        Input Set description  # noqa: E501

        :param description: The description of this InputSetResponseBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def error_details(self):
        """Gets the error_details of this InputSetResponseBody.  # noqa: E501


        :return: The error_details of this InputSetResponseBody.  # noqa: E501
        :rtype: InputSetErrorDetails
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """Sets the error_details of this InputSetResponseBody.


        :param error_details: The error_details of this InputSetResponseBody.  # noqa: E501
        :type: InputSetErrorDetails
        """

        self._error_details = error_details

    @property
    def git_details(self):
        """Gets the git_details of this InputSetResponseBody.  # noqa: E501


        :return: The git_details of this InputSetResponseBody.  # noqa: E501
        :rtype: GitDetails
        """
        return self._git_details

    @git_details.setter
    def git_details(self, git_details):
        """Sets the git_details of this InputSetResponseBody.


        :param git_details: The git_details of this InputSetResponseBody.  # noqa: E501
        :type: GitDetails
        """

        self._git_details = git_details

    @property
    def identifier(self):
        """Gets the identifier of this InputSetResponseBody.  # noqa: E501

        Input Set identifier  # noqa: E501

        :return: The identifier of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this InputSetResponseBody.

        Input Set identifier  # noqa: E501

        :param identifier: The identifier of this InputSetResponseBody.  # noqa: E501
        :type: str
        """

        self._identifier = identifier

    @property
    def input_set_yaml(self):
        """Gets the input_set_yaml of this InputSetResponseBody.  # noqa: E501

        Input Set YAML (returned as a String).  # noqa: E501

        :return: The input_set_yaml of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._input_set_yaml

    @input_set_yaml.setter
    def input_set_yaml(self, input_set_yaml):
        """Sets the input_set_yaml of this InputSetResponseBody.

        Input Set YAML (returned as a String).  # noqa: E501

        :param input_set_yaml: The input_set_yaml of this InputSetResponseBody.  # noqa: E501
        :type: str
        """

        self._input_set_yaml = input_set_yaml

    @property
    def name(self):
        """Gets the name of this InputSetResponseBody.  # noqa: E501

        Input Set name  # noqa: E501

        :return: The name of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InputSetResponseBody.

        Input Set name  # noqa: E501

        :param name: The name of this InputSetResponseBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def org(self):
        """Gets the org of this InputSetResponseBody.  # noqa: E501

        Organization identifier  # noqa: E501

        :return: The org of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._org

    @org.setter
    def org(self, org):
        """Sets the org of this InputSetResponseBody.

        Organization identifier  # noqa: E501

        :param org: The org of this InputSetResponseBody.  # noqa: E501
        :type: str
        """

        self._org = org

    @property
    def pipeline(self):
        """Gets the pipeline of this InputSetResponseBody.  # noqa: E501

        Pipeline identifier  # noqa: E501

        :return: The pipeline of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._pipeline

    @pipeline.setter
    def pipeline(self, pipeline):
        """Sets the pipeline of this InputSetResponseBody.

        Pipeline identifier  # noqa: E501

        :param pipeline: The pipeline of this InputSetResponseBody.  # noqa: E501
        :type: str
        """

        self._pipeline = pipeline

    @property
    def project(self):
        """Gets the project of this InputSetResponseBody.  # noqa: E501

        Project identifier  # noqa: E501

        :return: The project of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this InputSetResponseBody.

        Project identifier  # noqa: E501

        :param project: The project of this InputSetResponseBody.  # noqa: E501
        :type: str
        """

        self._project = project

    @property
    def store_type(self):
        """Gets the store_type of this InputSetResponseBody.  # noqa: E501

        Specifies whether the Entity is to be stored in Git or not (for Git Experience).  # noqa: E501

        :return: The store_type of this InputSetResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._store_type

    @store_type.setter
    def store_type(self, store_type):
        """Sets the store_type of this InputSetResponseBody.

        Specifies whether the Entity is to be stored in Git or not (for Git Experience).  # noqa: E501

        :param store_type: The store_type of this InputSetResponseBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["INLINE", "REMOTE"]  # noqa: E501
        if store_type not in allowed_values:
            raise ValueError(
                "Invalid value for `store_type` ({0}), must be one of {1}"  # noqa: E501
                .format(store_type, allowed_values)
            )

        self._store_type = store_type

    @property
    def tags(self):
        """Gets the tags of this InputSetResponseBody.  # noqa: E501

        Input Set tags  # noqa: E501

        :return: The tags of this InputSetResponseBody.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this InputSetResponseBody.

        Input Set tags  # noqa: E501

        :param tags: The tags of this InputSetResponseBody.  # noqa: E501
        :type: dict(str, str)
        """

        self._tags = tags

    @property
    def updated(self):
        """Gets the updated of this InputSetResponseBody.  # noqa: E501

        Last modification timestamp for Input Set.  # noqa: E501

        :return: The updated of this InputSetResponseBody.  # noqa: E501
        :rtype: int
        """
        return self._updated

    @updated.setter
    def updated(self, updated):
        """Sets the updated of this InputSetResponseBody.

        Last modification timestamp for Input Set.  # noqa: E501

        :param updated: The updated of this InputSetResponseBody.  # noqa: E501
        :type: int
        """

        self._updated = updated

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InputSetResponseBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InputSetResponseBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
