# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ListModuleMetadataResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account': 'str',
        'dependencies': 'list[DependenciesMetadata]',
        'metadata_error': 'str',
        'module_version': 'str',
        'name': 'str',
        'outputs': 'list[OutputMetadata]',
        'providers': 'list[ProviderMetadata]',
        'resources': 'list[ResourceMetadata]',
        'submodule': 'list[str]',
        'system': 'str',
        'variables': 'list[VariableMetadata]'
    }

    attribute_map = {
        'account': 'account',
        'dependencies': 'dependencies',
        'metadata_error': 'metadata_error',
        'module_version': 'module_version',
        'name': 'name',
        'outputs': 'outputs',
        'providers': 'providers',
        'resources': 'resources',
        'submodule': 'submodule',
        'system': 'system',
        'variables': 'variables'
    }

    def __init__(self, account=None, dependencies=None, metadata_error=None, module_version=None, name=None, outputs=None, providers=None, resources=None, submodule=None, system=None, variables=None):  # noqa: E501
        """ListModuleMetadataResponse - a model defined in Swagger"""  # noqa: E501
        self._account = None
        self._dependencies = None
        self._metadata_error = None
        self._module_version = None
        self._name = None
        self._outputs = None
        self._providers = None
        self._resources = None
        self._submodule = None
        self._system = None
        self._variables = None
        self.discriminator = None
        self.account = account
        if dependencies is not None:
            self.dependencies = dependencies
        if metadata_error is not None:
            self.metadata_error = metadata_error
        self.module_version = module_version
        self.name = name
        self.outputs = outputs
        self.providers = providers
        self.resources = resources
        if submodule is not None:
            self.submodule = submodule
        self.system = system
        self.variables = variables

    @property
    def account(self):
        """Gets the account of this ListModuleMetadataResponse.  # noqa: E501

        account name  # noqa: E501

        :return: The account of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: str
        """
        return self._account

    @account.setter
    def account(self, account):
        """Sets the account of this ListModuleMetadataResponse.

        account name  # noqa: E501

        :param account: The account of this ListModuleMetadataResponse.  # noqa: E501
        :type: str
        """
        if account is None:
            raise ValueError("Invalid value for `account`, must not be `None`")  # noqa: E501

        self._account = account

    @property
    def dependencies(self):
        """Gets the dependencies of this ListModuleMetadataResponse.  # noqa: E501

        Dependencies of the module  # noqa: E501

        :return: The dependencies of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: list[DependenciesMetadata]
        """
        return self._dependencies

    @dependencies.setter
    def dependencies(self, dependencies):
        """Sets the dependencies of this ListModuleMetadataResponse.

        Dependencies of the module  # noqa: E501

        :param dependencies: The dependencies of this ListModuleMetadataResponse.  # noqa: E501
        :type: list[DependenciesMetadata]
        """

        self._dependencies = dependencies

    @property
    def metadata_error(self):
        """Gets the metadata_error of this ListModuleMetadataResponse.  # noqa: E501

        error while retrieving the module  # noqa: E501

        :return: The metadata_error of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: str
        """
        return self._metadata_error

    @metadata_error.setter
    def metadata_error(self, metadata_error):
        """Sets the metadata_error of this ListModuleMetadataResponse.

        error while retrieving the module  # noqa: E501

        :param metadata_error: The metadata_error of this ListModuleMetadataResponse.  # noqa: E501
        :type: str
        """

        self._metadata_error = metadata_error

    @property
    def module_version(self):
        """Gets the module_version of this ListModuleMetadataResponse.  # noqa: E501

        module version  # noqa: E501

        :return: The module_version of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: str
        """
        return self._module_version

    @module_version.setter
    def module_version(self, module_version):
        """Sets the module_version of this ListModuleMetadataResponse.

        module version  # noqa: E501

        :param module_version: The module_version of this ListModuleMetadataResponse.  # noqa: E501
        :type: str
        """
        if module_version is None:
            raise ValueError("Invalid value for `module_version`, must not be `None`")  # noqa: E501

        self._module_version = module_version

    @property
    def name(self):
        """Gets the name of this ListModuleMetadataResponse.  # noqa: E501

        module name  # noqa: E501

        :return: The name of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ListModuleMetadataResponse.

        module name  # noqa: E501

        :param name: The name of this ListModuleMetadataResponse.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def outputs(self):
        """Gets the outputs of this ListModuleMetadataResponse.  # noqa: E501

        Outputs of the module  # noqa: E501

        :return: The outputs of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: list[OutputMetadata]
        """
        return self._outputs

    @outputs.setter
    def outputs(self, outputs):
        """Sets the outputs of this ListModuleMetadataResponse.

        Outputs of the module  # noqa: E501

        :param outputs: The outputs of this ListModuleMetadataResponse.  # noqa: E501
        :type: list[OutputMetadata]
        """
        if outputs is None:
            raise ValueError("Invalid value for `outputs`, must not be `None`")  # noqa: E501

        self._outputs = outputs

    @property
    def providers(self):
        """Gets the providers of this ListModuleMetadataResponse.  # noqa: E501

        Providers of the module  # noqa: E501

        :return: The providers of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: list[ProviderMetadata]
        """
        return self._providers

    @providers.setter
    def providers(self, providers):
        """Sets the providers of this ListModuleMetadataResponse.

        Providers of the module  # noqa: E501

        :param providers: The providers of this ListModuleMetadataResponse.  # noqa: E501
        :type: list[ProviderMetadata]
        """
        if providers is None:
            raise ValueError("Invalid value for `providers`, must not be `None`")  # noqa: E501

        self._providers = providers

    @property
    def resources(self):
        """Gets the resources of this ListModuleMetadataResponse.  # noqa: E501

        Resources of the module  # noqa: E501

        :return: The resources of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: list[ResourceMetadata]
        """
        return self._resources

    @resources.setter
    def resources(self, resources):
        """Sets the resources of this ListModuleMetadataResponse.

        Resources of the module  # noqa: E501

        :param resources: The resources of this ListModuleMetadataResponse.  # noqa: E501
        :type: list[ResourceMetadata]
        """
        if resources is None:
            raise ValueError("Invalid value for `resources`, must not be `None`")  # noqa: E501

        self._resources = resources

    @property
    def submodule(self):
        """Gets the submodule of this ListModuleMetadataResponse.  # noqa: E501

        Submodules of the module  # noqa: E501

        :return: The submodule of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._submodule

    @submodule.setter
    def submodule(self, submodule):
        """Sets the submodule of this ListModuleMetadataResponse.

        Submodules of the module  # noqa: E501

        :param submodule: The submodule of this ListModuleMetadataResponse.  # noqa: E501
        :type: list[str]
        """

        self._submodule = submodule

    @property
    def system(self):
        """Gets the system of this ListModuleMetadataResponse.  # noqa: E501

        system name  # noqa: E501

        :return: The system of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: str
        """
        return self._system

    @system.setter
    def system(self, system):
        """Sets the system of this ListModuleMetadataResponse.

        system name  # noqa: E501

        :param system: The system of this ListModuleMetadataResponse.  # noqa: E501
        :type: str
        """
        if system is None:
            raise ValueError("Invalid value for `system`, must not be `None`")  # noqa: E501

        self._system = system

    @property
    def variables(self):
        """Gets the variables of this ListModuleMetadataResponse.  # noqa: E501

        Variables of the module  # noqa: E501

        :return: The variables of this ListModuleMetadataResponse.  # noqa: E501
        :rtype: list[VariableMetadata]
        """
        return self._variables

    @variables.setter
    def variables(self, variables):
        """Sets the variables of this ListModuleMetadataResponse.

        Variables of the module  # noqa: E501

        :param variables: The variables of this ListModuleMetadataResponse.  # noqa: E501
        :type: list[VariableMetadata]
        """
        if variables is None:
            raise ValueError("Invalid value for `variables`, must not be `None`")  # noqa: E501

        self._variables = variables

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ListModuleMetadataResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ListModuleMetadataResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
