# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class MethodDescriptorProtoOrBuilder(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'all_fields': 'dict(str, object)',
        'client_streaming': 'bool',
        'default_instance_for_type': 'Message',
        'descriptor_for_type': 'Descriptor',
        'initialization_error_string': 'str',
        'initialized': 'bool',
        'input_type': 'str',
        'input_type_bytes': 'ByteString',
        'name': 'str',
        'name_bytes': 'ByteString',
        'options': 'MethodOptions',
        'options_or_builder': 'MethodOptionsOrBuilder',
        'output_type': 'str',
        'output_type_bytes': 'ByteString',
        'server_streaming': 'bool',
        'unknown_fields': 'UnknownFieldSet'
    }

    attribute_map = {
        'all_fields': 'allFields',
        'client_streaming': 'clientStreaming',
        'default_instance_for_type': 'defaultInstanceForType',
        'descriptor_for_type': 'descriptorForType',
        'initialization_error_string': 'initializationErrorString',
        'initialized': 'initialized',
        'input_type': 'inputType',
        'input_type_bytes': 'inputTypeBytes',
        'name': 'name',
        'name_bytes': 'nameBytes',
        'options': 'options',
        'options_or_builder': 'optionsOrBuilder',
        'output_type': 'outputType',
        'output_type_bytes': 'outputTypeBytes',
        'server_streaming': 'serverStreaming',
        'unknown_fields': 'unknownFields'
    }

    def __init__(self, all_fields=None, client_streaming=None, default_instance_for_type=None, descriptor_for_type=None, initialization_error_string=None, initialized=None, input_type=None, input_type_bytes=None, name=None, name_bytes=None, options=None, options_or_builder=None, output_type=None, output_type_bytes=None, server_streaming=None, unknown_fields=None):  # noqa: E501
        """MethodDescriptorProtoOrBuilder - a model defined in Swagger"""  # noqa: E501
        self._all_fields = None
        self._client_streaming = None
        self._default_instance_for_type = None
        self._descriptor_for_type = None
        self._initialization_error_string = None
        self._initialized = None
        self._input_type = None
        self._input_type_bytes = None
        self._name = None
        self._name_bytes = None
        self._options = None
        self._options_or_builder = None
        self._output_type = None
        self._output_type_bytes = None
        self._server_streaming = None
        self._unknown_fields = None
        self.discriminator = None
        if all_fields is not None:
            self.all_fields = all_fields
        if client_streaming is not None:
            self.client_streaming = client_streaming
        if default_instance_for_type is not None:
            self.default_instance_for_type = default_instance_for_type
        if descriptor_for_type is not None:
            self.descriptor_for_type = descriptor_for_type
        if initialization_error_string is not None:
            self.initialization_error_string = initialization_error_string
        if initialized is not None:
            self.initialized = initialized
        if input_type is not None:
            self.input_type = input_type
        if input_type_bytes is not None:
            self.input_type_bytes = input_type_bytes
        if name is not None:
            self.name = name
        if name_bytes is not None:
            self.name_bytes = name_bytes
        if options is not None:
            self.options = options
        if options_or_builder is not None:
            self.options_or_builder = options_or_builder
        if output_type is not None:
            self.output_type = output_type
        if output_type_bytes is not None:
            self.output_type_bytes = output_type_bytes
        if server_streaming is not None:
            self.server_streaming = server_streaming
        if unknown_fields is not None:
            self.unknown_fields = unknown_fields

    @property
    def all_fields(self):
        """Gets the all_fields of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The all_fields of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._all_fields

    @all_fields.setter
    def all_fields(self, all_fields):
        """Sets the all_fields of this MethodDescriptorProtoOrBuilder.


        :param all_fields: The all_fields of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: dict(str, object)
        """

        self._all_fields = all_fields

    @property
    def client_streaming(self):
        """Gets the client_streaming of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The client_streaming of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: bool
        """
        return self._client_streaming

    @client_streaming.setter
    def client_streaming(self, client_streaming):
        """Sets the client_streaming of this MethodDescriptorProtoOrBuilder.


        :param client_streaming: The client_streaming of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: bool
        """

        self._client_streaming = client_streaming

    @property
    def default_instance_for_type(self):
        """Gets the default_instance_for_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The default_instance_for_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: Message
        """
        return self._default_instance_for_type

    @default_instance_for_type.setter
    def default_instance_for_type(self, default_instance_for_type):
        """Sets the default_instance_for_type of this MethodDescriptorProtoOrBuilder.


        :param default_instance_for_type: The default_instance_for_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: Message
        """

        self._default_instance_for_type = default_instance_for_type

    @property
    def descriptor_for_type(self):
        """Gets the descriptor_for_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The descriptor_for_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: Descriptor
        """
        return self._descriptor_for_type

    @descriptor_for_type.setter
    def descriptor_for_type(self, descriptor_for_type):
        """Sets the descriptor_for_type of this MethodDescriptorProtoOrBuilder.


        :param descriptor_for_type: The descriptor_for_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: Descriptor
        """

        self._descriptor_for_type = descriptor_for_type

    @property
    def initialization_error_string(self):
        """Gets the initialization_error_string of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The initialization_error_string of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: str
        """
        return self._initialization_error_string

    @initialization_error_string.setter
    def initialization_error_string(self, initialization_error_string):
        """Sets the initialization_error_string of this MethodDescriptorProtoOrBuilder.


        :param initialization_error_string: The initialization_error_string of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: str
        """

        self._initialization_error_string = initialization_error_string

    @property
    def initialized(self):
        """Gets the initialized of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The initialized of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: bool
        """
        return self._initialized

    @initialized.setter
    def initialized(self, initialized):
        """Sets the initialized of this MethodDescriptorProtoOrBuilder.


        :param initialized: The initialized of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: bool
        """

        self._initialized = initialized

    @property
    def input_type(self):
        """Gets the input_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The input_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: str
        """
        return self._input_type

    @input_type.setter
    def input_type(self, input_type):
        """Sets the input_type of this MethodDescriptorProtoOrBuilder.


        :param input_type: The input_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: str
        """

        self._input_type = input_type

    @property
    def input_type_bytes(self):
        """Gets the input_type_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The input_type_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: ByteString
        """
        return self._input_type_bytes

    @input_type_bytes.setter
    def input_type_bytes(self, input_type_bytes):
        """Sets the input_type_bytes of this MethodDescriptorProtoOrBuilder.


        :param input_type_bytes: The input_type_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: ByteString
        """

        self._input_type_bytes = input_type_bytes

    @property
    def name(self):
        """Gets the name of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The name of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this MethodDescriptorProtoOrBuilder.


        :param name: The name of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def name_bytes(self):
        """Gets the name_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The name_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: ByteString
        """
        return self._name_bytes

    @name_bytes.setter
    def name_bytes(self, name_bytes):
        """Sets the name_bytes of this MethodDescriptorProtoOrBuilder.


        :param name_bytes: The name_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: ByteString
        """

        self._name_bytes = name_bytes

    @property
    def options(self):
        """Gets the options of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The options of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: MethodOptions
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this MethodDescriptorProtoOrBuilder.


        :param options: The options of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: MethodOptions
        """

        self._options = options

    @property
    def options_or_builder(self):
        """Gets the options_or_builder of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The options_or_builder of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: MethodOptionsOrBuilder
        """
        return self._options_or_builder

    @options_or_builder.setter
    def options_or_builder(self, options_or_builder):
        """Sets the options_or_builder of this MethodDescriptorProtoOrBuilder.


        :param options_or_builder: The options_or_builder of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: MethodOptionsOrBuilder
        """

        self._options_or_builder = options_or_builder

    @property
    def output_type(self):
        """Gets the output_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The output_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: str
        """
        return self._output_type

    @output_type.setter
    def output_type(self, output_type):
        """Sets the output_type of this MethodDescriptorProtoOrBuilder.


        :param output_type: The output_type of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: str
        """

        self._output_type = output_type

    @property
    def output_type_bytes(self):
        """Gets the output_type_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The output_type_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: ByteString
        """
        return self._output_type_bytes

    @output_type_bytes.setter
    def output_type_bytes(self, output_type_bytes):
        """Sets the output_type_bytes of this MethodDescriptorProtoOrBuilder.


        :param output_type_bytes: The output_type_bytes of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: ByteString
        """

        self._output_type_bytes = output_type_bytes

    @property
    def server_streaming(self):
        """Gets the server_streaming of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The server_streaming of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: bool
        """
        return self._server_streaming

    @server_streaming.setter
    def server_streaming(self, server_streaming):
        """Sets the server_streaming of this MethodDescriptorProtoOrBuilder.


        :param server_streaming: The server_streaming of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: bool
        """

        self._server_streaming = server_streaming

    @property
    def unknown_fields(self):
        """Gets the unknown_fields of this MethodDescriptorProtoOrBuilder.  # noqa: E501


        :return: The unknown_fields of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :rtype: UnknownFieldSet
        """
        return self._unknown_fields

    @unknown_fields.setter
    def unknown_fields(self, unknown_fields):
        """Sets the unknown_fields of this MethodDescriptorProtoOrBuilder.


        :param unknown_fields: The unknown_fields of this MethodDescriptorProtoOrBuilder.  # noqa: E501
        :type: UnknownFieldSet
        """

        self._unknown_fields = unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MethodDescriptorProtoOrBuilder, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MethodDescriptorProtoOrBuilder):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
