# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class MigrationStateInstance(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'error': 'str',
        'instance': 'str',
        'pipeline': 'str',
        'plan_execution_id': 'str',
        'stage_execution_id': 'str',
        'status': 'ChangeSetDeploymentStatus',
        'updated': 'int'
    }

    attribute_map = {
        'error': 'error',
        'instance': 'instance',
        'pipeline': 'pipeline',
        'plan_execution_id': 'planExecutionId',
        'stage_execution_id': 'stageExecutionId',
        'status': 'status',
        'updated': 'updated'
    }

    def __init__(self, error=None, instance=None, pipeline=None, plan_execution_id=None, stage_execution_id=None, status=None, updated=None):  # noqa: E501
        """MigrationStateInstance - a model defined in Swagger"""  # noqa: E501
        self._error = None
        self._instance = None
        self._pipeline = None
        self._plan_execution_id = None
        self._stage_execution_id = None
        self._status = None
        self._updated = None
        self.discriminator = None
        if error is not None:
            self.error = error
        self.instance = instance
        self.pipeline = pipeline
        self.plan_execution_id = plan_execution_id
        self.stage_execution_id = stage_execution_id
        self.status = status
        if updated is not None:
            self.updated = updated

    @property
    def error(self):
        """Gets the error of this MigrationStateInstance.  # noqa: E501


        :return: The error of this MigrationStateInstance.  # noqa: E501
        :rtype: str
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this MigrationStateInstance.


        :param error: The error of this MigrationStateInstance.  # noqa: E501
        :type: str
        """

        self._error = error

    @property
    def instance(self):
        """Gets the instance of this MigrationStateInstance.  # noqa: E501

        Identfier of the instance  # noqa: E501

        :return: The instance of this MigrationStateInstance.  # noqa: E501
        :rtype: str
        """
        return self._instance

    @instance.setter
    def instance(self, instance):
        """Sets the instance of this MigrationStateInstance.

        Identfier of the instance  # noqa: E501

        :param instance: The instance of this MigrationStateInstance.  # noqa: E501
        :type: str
        """
        if instance is None:
            raise ValueError("Invalid value for `instance`, must not be `None`")  # noqa: E501

        self._instance = instance

    @property
    def pipeline(self):
        """Gets the pipeline of this MigrationStateInstance.  # noqa: E501


        :return: The pipeline of this MigrationStateInstance.  # noqa: E501
        :rtype: str
        """
        return self._pipeline

    @pipeline.setter
    def pipeline(self, pipeline):
        """Sets the pipeline of this MigrationStateInstance.


        :param pipeline: The pipeline of this MigrationStateInstance.  # noqa: E501
        :type: str
        """
        if pipeline is None:
            raise ValueError("Invalid value for `pipeline`, must not be `None`")  # noqa: E501

        self._pipeline = pipeline

    @property
    def plan_execution_id(self):
        """Gets the plan_execution_id of this MigrationStateInstance.  # noqa: E501


        :return: The plan_execution_id of this MigrationStateInstance.  # noqa: E501
        :rtype: str
        """
        return self._plan_execution_id

    @plan_execution_id.setter
    def plan_execution_id(self, plan_execution_id):
        """Sets the plan_execution_id of this MigrationStateInstance.


        :param plan_execution_id: The plan_execution_id of this MigrationStateInstance.  # noqa: E501
        :type: str
        """
        if plan_execution_id is None:
            raise ValueError("Invalid value for `plan_execution_id`, must not be `None`")  # noqa: E501

        self._plan_execution_id = plan_execution_id

    @property
    def stage_execution_id(self):
        """Gets the stage_execution_id of this MigrationStateInstance.  # noqa: E501


        :return: The stage_execution_id of this MigrationStateInstance.  # noqa: E501
        :rtype: str
        """
        return self._stage_execution_id

    @stage_execution_id.setter
    def stage_execution_id(self, stage_execution_id):
        """Sets the stage_execution_id of this MigrationStateInstance.


        :param stage_execution_id: The stage_execution_id of this MigrationStateInstance.  # noqa: E501
        :type: str
        """
        if stage_execution_id is None:
            raise ValueError("Invalid value for `stage_execution_id`, must not be `None`")  # noqa: E501

        self._stage_execution_id = stage_execution_id

    @property
    def status(self):
        """Gets the status of this MigrationStateInstance.  # noqa: E501


        :return: The status of this MigrationStateInstance.  # noqa: E501
        :rtype: ChangeSetDeploymentStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this MigrationStateInstance.


        :param status: The status of this MigrationStateInstance.  # noqa: E501
        :type: ChangeSetDeploymentStatus
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def updated(self):
        """Gets the updated of this MigrationStateInstance.  # noqa: E501

        Time of last Change Set Deployment/Rollback attempt   # noqa: E501

        :return: The updated of this MigrationStateInstance.  # noqa: E501
        :rtype: int
        """
        return self._updated

    @updated.setter
    def updated(self, updated):
        """Sets the updated of this MigrationStateInstance.

        Time of last Change Set Deployment/Rollback attempt   # noqa: E501

        :param updated: The updated of this MigrationStateInstance.  # noqa: E501
        :type: int
        """

        self._updated = updated

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MigrationStateInstance, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrationStateInstance):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
