# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PluginInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'category': 'str',
        'core': 'bool',
        'created_by': 'str',
        'description': 'str',
        'documentation': 'str',
        'enabled': 'bool',
        'icon_url': 'str',
        'id': 'str',
        'image_url': 'str',
        'images': 'list[str]',
        'name': 'str',
        'plugin_type': 'str',
        'source': 'str'
    }

    attribute_map = {
        'category': 'category',
        'core': 'core',
        'created_by': 'created_by',
        'description': 'description',
        'documentation': 'documentation',
        'enabled': 'enabled',
        'icon_url': 'icon_url',
        'id': 'id',
        'image_url': 'image_url',
        'images': 'images',
        'name': 'name',
        'plugin_type': 'plugin_type',
        'source': 'source'
    }

    def __init__(self, category=None, core=None, created_by=None, description=None, documentation=None, enabled=None, icon_url=None, id=None, image_url=None, images=None, name=None, plugin_type=None, source=None):  # noqa: E501
        """PluginInfo - a model defined in Swagger"""  # noqa: E501
        self._category = None
        self._core = None
        self._created_by = None
        self._description = None
        self._documentation = None
        self._enabled = None
        self._icon_url = None
        self._id = None
        self._image_url = None
        self._images = None
        self._name = None
        self._plugin_type = None
        self._source = None
        self.discriminator = None
        if category is not None:
            self.category = category
        if core is not None:
            self.core = core
        if created_by is not None:
            self.created_by = created_by
        if description is not None:
            self.description = description
        if documentation is not None:
            self.documentation = documentation
        if enabled is not None:
            self.enabled = enabled
        if icon_url is not None:
            self.icon_url = icon_url
        self.id = id
        if image_url is not None:
            self.image_url = image_url
        if images is not None:
            self.images = images
        if name is not None:
            self.name = name
        if plugin_type is not None:
            self.plugin_type = plugin_type
        if source is not None:
            self.source = source

    @property
    def category(self):
        """Gets the category of this PluginInfo.  # noqa: E501


        :return: The category of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this PluginInfo.


        :param category: The category of this PluginInfo.  # noqa: E501
        :type: str
        """

        self._category = category

    @property
    def core(self):
        """Gets the core of this PluginInfo.  # noqa: E501


        :return: The core of this PluginInfo.  # noqa: E501
        :rtype: bool
        """
        return self._core

    @core.setter
    def core(self, core):
        """Sets the core of this PluginInfo.


        :param core: The core of this PluginInfo.  # noqa: E501
        :type: bool
        """

        self._core = core

    @property
    def created_by(self):
        """Gets the created_by of this PluginInfo.  # noqa: E501


        :return: The created_by of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this PluginInfo.


        :param created_by: The created_by of this PluginInfo.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def description(self):
        """Gets the description of this PluginInfo.  # noqa: E501


        :return: The description of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PluginInfo.


        :param description: The description of this PluginInfo.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def documentation(self):
        """Gets the documentation of this PluginInfo.  # noqa: E501


        :return: The documentation of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._documentation

    @documentation.setter
    def documentation(self, documentation):
        """Sets the documentation of this PluginInfo.


        :param documentation: The documentation of this PluginInfo.  # noqa: E501
        :type: str
        """

        self._documentation = documentation

    @property
    def enabled(self):
        """Gets the enabled of this PluginInfo.  # noqa: E501


        :return: The enabled of this PluginInfo.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this PluginInfo.


        :param enabled: The enabled of this PluginInfo.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def icon_url(self):
        """Gets the icon_url of this PluginInfo.  # noqa: E501


        :return: The icon_url of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._icon_url

    @icon_url.setter
    def icon_url(self, icon_url):
        """Sets the icon_url of this PluginInfo.


        :param icon_url: The icon_url of this PluginInfo.  # noqa: E501
        :type: str
        """

        self._icon_url = icon_url

    @property
    def id(self):
        """Gets the id of this PluginInfo.  # noqa: E501


        :return: The id of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PluginInfo.


        :param id: The id of this PluginInfo.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def image_url(self):
        """Gets the image_url of this PluginInfo.  # noqa: E501


        :return: The image_url of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._image_url

    @image_url.setter
    def image_url(self, image_url):
        """Sets the image_url of this PluginInfo.


        :param image_url: The image_url of this PluginInfo.  # noqa: E501
        :type: str
        """

        self._image_url = image_url

    @property
    def images(self):
        """Gets the images of this PluginInfo.  # noqa: E501


        :return: The images of this PluginInfo.  # noqa: E501
        :rtype: list[str]
        """
        return self._images

    @images.setter
    def images(self, images):
        """Sets the images of this PluginInfo.


        :param images: The images of this PluginInfo.  # noqa: E501
        :type: list[str]
        """

        self._images = images

    @property
    def name(self):
        """Gets the name of this PluginInfo.  # noqa: E501


        :return: The name of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PluginInfo.


        :param name: The name of this PluginInfo.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def plugin_type(self):
        """Gets the plugin_type of this PluginInfo.  # noqa: E501


        :return: The plugin_type of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._plugin_type

    @plugin_type.setter
    def plugin_type(self, plugin_type):
        """Sets the plugin_type of this PluginInfo.


        :param plugin_type: The plugin_type of this PluginInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["DEFAULT", "CUSTOM"]  # noqa: E501
        if plugin_type not in allowed_values:
            raise ValueError(
                "Invalid value for `plugin_type` ({0}), must be one of {1}"  # noqa: E501
                .format(plugin_type, allowed_values)
            )

        self._plugin_type = plugin_type

    @property
    def source(self):
        """Gets the source of this PluginInfo.  # noqa: E501


        :return: The source of this PluginInfo.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this PluginInfo.


        :param source: The source of this PluginInfo.  # noqa: E501
        :type: str
        """

        self._source = source

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PluginInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PluginInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
