# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PMSPipelineResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'allow_dynamic_executions': 'bool',
        'cache_response': 'CacheResponseMetadata',
        'connector_ref': 'str',
        'entity_validity_details': 'PipelineEntityGitDetails',
        'git_details': 'PipelineEntityGitDetails',
        'governance_metadata': 'PipelineGovernanceMetadata',
        'is_inline_hc_entity': 'bool',
        'modules': 'list[str]',
        'public_access_response': 'PublicAccessResponse',
        'resolved_templates_pipeline_yaml': 'str',
        'store_type': 'str',
        'validate_template_inputs_response': 'ValidateTemplateInputsResponseDTO',
        'validation_uuid': 'str',
        'yaml_pipeline': 'str',
        'yaml_schema_error_wrapper': 'YamlSchemaErrorWrapperDTO'
    }

    attribute_map = {
        'allow_dynamic_executions': 'allowDynamicExecutions',
        'cache_response': 'cacheResponse',
        'connector_ref': 'connectorRef',
        'entity_validity_details': 'entityValidityDetails',
        'git_details': 'gitDetails',
        'governance_metadata': 'governanceMetadata',
        'is_inline_hc_entity': 'isInlineHCEntity',
        'modules': 'modules',
        'public_access_response': 'publicAccessResponse',
        'resolved_templates_pipeline_yaml': 'resolvedTemplatesPipelineYaml',
        'store_type': 'storeType',
        'validate_template_inputs_response': 'validateTemplateInputsResponse',
        'validation_uuid': 'validationUuid',
        'yaml_pipeline': 'yamlPipeline',
        'yaml_schema_error_wrapper': 'yamlSchemaErrorWrapper'
    }

    def __init__(self, allow_dynamic_executions=None, cache_response=None, connector_ref=None, entity_validity_details=None, git_details=None, governance_metadata=None, is_inline_hc_entity=None, modules=None, public_access_response=None, resolved_templates_pipeline_yaml=None, store_type=None, validate_template_inputs_response=None, validation_uuid=None, yaml_pipeline=None, yaml_schema_error_wrapper=None):  # noqa: E501
        """PMSPipelineResponse - a model defined in Swagger"""  # noqa: E501
        self._allow_dynamic_executions = None
        self._cache_response = None
        self._connector_ref = None
        self._entity_validity_details = None
        self._git_details = None
        self._governance_metadata = None
        self._is_inline_hc_entity = None
        self._modules = None
        self._public_access_response = None
        self._resolved_templates_pipeline_yaml = None
        self._store_type = None
        self._validate_template_inputs_response = None
        self._validation_uuid = None
        self._yaml_pipeline = None
        self._yaml_schema_error_wrapper = None
        self.discriminator = None
        if allow_dynamic_executions is not None:
            self.allow_dynamic_executions = allow_dynamic_executions
        if cache_response is not None:
            self.cache_response = cache_response
        if connector_ref is not None:
            self.connector_ref = connector_ref
        if entity_validity_details is not None:
            self.entity_validity_details = entity_validity_details
        if git_details is not None:
            self.git_details = git_details
        if governance_metadata is not None:
            self.governance_metadata = governance_metadata
        if is_inline_hc_entity is not None:
            self.is_inline_hc_entity = is_inline_hc_entity
        if modules is not None:
            self.modules = modules
        if public_access_response is not None:
            self.public_access_response = public_access_response
        if resolved_templates_pipeline_yaml is not None:
            self.resolved_templates_pipeline_yaml = resolved_templates_pipeline_yaml
        if store_type is not None:
            self.store_type = store_type
        if validate_template_inputs_response is not None:
            self.validate_template_inputs_response = validate_template_inputs_response
        if validation_uuid is not None:
            self.validation_uuid = validation_uuid
        if yaml_pipeline is not None:
            self.yaml_pipeline = yaml_pipeline
        if yaml_schema_error_wrapper is not None:
            self.yaml_schema_error_wrapper = yaml_schema_error_wrapper

    @property
    def allow_dynamic_executions(self):
        """Gets the allow_dynamic_executions of this PMSPipelineResponse.  # noqa: E501


        :return: The allow_dynamic_executions of this PMSPipelineResponse.  # noqa: E501
        :rtype: bool
        """
        return self._allow_dynamic_executions

    @allow_dynamic_executions.setter
    def allow_dynamic_executions(self, allow_dynamic_executions):
        """Sets the allow_dynamic_executions of this PMSPipelineResponse.


        :param allow_dynamic_executions: The allow_dynamic_executions of this PMSPipelineResponse.  # noqa: E501
        :type: bool
        """

        self._allow_dynamic_executions = allow_dynamic_executions

    @property
    def cache_response(self):
        """Gets the cache_response of this PMSPipelineResponse.  # noqa: E501


        :return: The cache_response of this PMSPipelineResponse.  # noqa: E501
        :rtype: CacheResponseMetadata
        """
        return self._cache_response

    @cache_response.setter
    def cache_response(self, cache_response):
        """Sets the cache_response of this PMSPipelineResponse.


        :param cache_response: The cache_response of this PMSPipelineResponse.  # noqa: E501
        :type: CacheResponseMetadata
        """

        self._cache_response = cache_response

    @property
    def connector_ref(self):
        """Gets the connector_ref of this PMSPipelineResponse.  # noqa: E501


        :return: The connector_ref of this PMSPipelineResponse.  # noqa: E501
        :rtype: str
        """
        return self._connector_ref

    @connector_ref.setter
    def connector_ref(self, connector_ref):
        """Sets the connector_ref of this PMSPipelineResponse.


        :param connector_ref: The connector_ref of this PMSPipelineResponse.  # noqa: E501
        :type: str
        """

        self._connector_ref = connector_ref

    @property
    def entity_validity_details(self):
        """Gets the entity_validity_details of this PMSPipelineResponse.  # noqa: E501


        :return: The entity_validity_details of this PMSPipelineResponse.  # noqa: E501
        :rtype: PipelineEntityGitDetails
        """
        return self._entity_validity_details

    @entity_validity_details.setter
    def entity_validity_details(self, entity_validity_details):
        """Sets the entity_validity_details of this PMSPipelineResponse.


        :param entity_validity_details: The entity_validity_details of this PMSPipelineResponse.  # noqa: E501
        :type: PipelineEntityGitDetails
        """

        self._entity_validity_details = entity_validity_details

    @property
    def git_details(self):
        """Gets the git_details of this PMSPipelineResponse.  # noqa: E501


        :return: The git_details of this PMSPipelineResponse.  # noqa: E501
        :rtype: PipelineEntityGitDetails
        """
        return self._git_details

    @git_details.setter
    def git_details(self, git_details):
        """Sets the git_details of this PMSPipelineResponse.


        :param git_details: The git_details of this PMSPipelineResponse.  # noqa: E501
        :type: PipelineEntityGitDetails
        """

        self._git_details = git_details

    @property
    def governance_metadata(self):
        """Gets the governance_metadata of this PMSPipelineResponse.  # noqa: E501


        :return: The governance_metadata of this PMSPipelineResponse.  # noqa: E501
        :rtype: PipelineGovernanceMetadata
        """
        return self._governance_metadata

    @governance_metadata.setter
    def governance_metadata(self, governance_metadata):
        """Sets the governance_metadata of this PMSPipelineResponse.


        :param governance_metadata: The governance_metadata of this PMSPipelineResponse.  # noqa: E501
        :type: PipelineGovernanceMetadata
        """

        self._governance_metadata = governance_metadata

    @property
    def is_inline_hc_entity(self):
        """Gets the is_inline_hc_entity of this PMSPipelineResponse.  # noqa: E501


        :return: The is_inline_hc_entity of this PMSPipelineResponse.  # noqa: E501
        :rtype: bool
        """
        return self._is_inline_hc_entity

    @is_inline_hc_entity.setter
    def is_inline_hc_entity(self, is_inline_hc_entity):
        """Sets the is_inline_hc_entity of this PMSPipelineResponse.


        :param is_inline_hc_entity: The is_inline_hc_entity of this PMSPipelineResponse.  # noqa: E501
        :type: bool
        """

        self._is_inline_hc_entity = is_inline_hc_entity

    @property
    def modules(self):
        """Gets the modules of this PMSPipelineResponse.  # noqa: E501


        :return: The modules of this PMSPipelineResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._modules

    @modules.setter
    def modules(self, modules):
        """Sets the modules of this PMSPipelineResponse.


        :param modules: The modules of this PMSPipelineResponse.  # noqa: E501
        :type: list[str]
        """

        self._modules = modules

    @property
    def public_access_response(self):
        """Gets the public_access_response of this PMSPipelineResponse.  # noqa: E501


        :return: The public_access_response of this PMSPipelineResponse.  # noqa: E501
        :rtype: PublicAccessResponse
        """
        return self._public_access_response

    @public_access_response.setter
    def public_access_response(self, public_access_response):
        """Sets the public_access_response of this PMSPipelineResponse.


        :param public_access_response: The public_access_response of this PMSPipelineResponse.  # noqa: E501
        :type: PublicAccessResponse
        """

        self._public_access_response = public_access_response

    @property
    def resolved_templates_pipeline_yaml(self):
        """Gets the resolved_templates_pipeline_yaml of this PMSPipelineResponse.  # noqa: E501

        Pipeline YAML after resolving templates  # noqa: E501

        :return: The resolved_templates_pipeline_yaml of this PMSPipelineResponse.  # noqa: E501
        :rtype: str
        """
        return self._resolved_templates_pipeline_yaml

    @resolved_templates_pipeline_yaml.setter
    def resolved_templates_pipeline_yaml(self, resolved_templates_pipeline_yaml):
        """Sets the resolved_templates_pipeline_yaml of this PMSPipelineResponse.

        Pipeline YAML after resolving templates  # noqa: E501

        :param resolved_templates_pipeline_yaml: The resolved_templates_pipeline_yaml of this PMSPipelineResponse.  # noqa: E501
        :type: str
        """

        self._resolved_templates_pipeline_yaml = resolved_templates_pipeline_yaml

    @property
    def store_type(self):
        """Gets the store_type of this PMSPipelineResponse.  # noqa: E501


        :return: The store_type of this PMSPipelineResponse.  # noqa: E501
        :rtype: str
        """
        return self._store_type

    @store_type.setter
    def store_type(self, store_type):
        """Sets the store_type of this PMSPipelineResponse.


        :param store_type: The store_type of this PMSPipelineResponse.  # noqa: E501
        :type: str
        """
        allowed_values = ["INLINE", "REMOTE", "INLINE_HC"]  # noqa: E501
        if store_type not in allowed_values:
            raise ValueError(
                "Invalid value for `store_type` ({0}), must be one of {1}"  # noqa: E501
                .format(store_type, allowed_values)
            )

        self._store_type = store_type

    @property
    def validate_template_inputs_response(self):
        """Gets the validate_template_inputs_response of this PMSPipelineResponse.  # noqa: E501


        :return: The validate_template_inputs_response of this PMSPipelineResponse.  # noqa: E501
        :rtype: ValidateTemplateInputsResponseDTO
        """
        return self._validate_template_inputs_response

    @validate_template_inputs_response.setter
    def validate_template_inputs_response(self, validate_template_inputs_response):
        """Sets the validate_template_inputs_response of this PMSPipelineResponse.


        :param validate_template_inputs_response: The validate_template_inputs_response of this PMSPipelineResponse.  # noqa: E501
        :type: ValidateTemplateInputsResponseDTO
        """

        self._validate_template_inputs_response = validate_template_inputs_response

    @property
    def validation_uuid(self):
        """Gets the validation_uuid of this PMSPipelineResponse.  # noqa: E501


        :return: The validation_uuid of this PMSPipelineResponse.  # noqa: E501
        :rtype: str
        """
        return self._validation_uuid

    @validation_uuid.setter
    def validation_uuid(self, validation_uuid):
        """Sets the validation_uuid of this PMSPipelineResponse.


        :param validation_uuid: The validation_uuid of this PMSPipelineResponse.  # noqa: E501
        :type: str
        """

        self._validation_uuid = validation_uuid

    @property
    def yaml_pipeline(self):
        """Gets the yaml_pipeline of this PMSPipelineResponse.  # noqa: E501


        :return: The yaml_pipeline of this PMSPipelineResponse.  # noqa: E501
        :rtype: str
        """
        return self._yaml_pipeline

    @yaml_pipeline.setter
    def yaml_pipeline(self, yaml_pipeline):
        """Sets the yaml_pipeline of this PMSPipelineResponse.


        :param yaml_pipeline: The yaml_pipeline of this PMSPipelineResponse.  # noqa: E501
        :type: str
        """

        self._yaml_pipeline = yaml_pipeline

    @property
    def yaml_schema_error_wrapper(self):
        """Gets the yaml_schema_error_wrapper of this PMSPipelineResponse.  # noqa: E501


        :return: The yaml_schema_error_wrapper of this PMSPipelineResponse.  # noqa: E501
        :rtype: YamlSchemaErrorWrapperDTO
        """
        return self._yaml_schema_error_wrapper

    @yaml_schema_error_wrapper.setter
    def yaml_schema_error_wrapper(self, yaml_schema_error_wrapper):
        """Sets the yaml_schema_error_wrapper of this PMSPipelineResponse.


        :param yaml_schema_error_wrapper: The yaml_schema_error_wrapper of this PMSPipelineResponse.  # noqa: E501
        :type: YamlSchemaErrorWrapperDTO
        """

        self._yaml_schema_error_wrapper = yaml_schema_error_wrapper

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PMSPipelineResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PMSPipelineResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
