# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RemediationListingResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'artifacts': 'int',
        'closed_by': 'str',
        'component': 'str',
        'contact': 'ContactInfo',
        'created_at': 'int',
        'created_by': 'str',
        'cve': 'str',
        'deployments_count': 'DeploymentsCount',
        'id': 'str',
        'remediation_condition': 'RemediationCondition',
        'schedule_status': 'str',
        'severity': 'VulnerabilitySeverity',
        'status': 'RemediationStatus',
        'target_date': 'str'
    }

    attribute_map = {
        'artifacts': 'artifacts',
        'closed_by': 'closed_by',
        'component': 'component',
        'contact': 'contact',
        'created_at': 'created_at',
        'created_by': 'created_by',
        'cve': 'cve',
        'deployments_count': 'deployments_count',
        'id': 'id',
        'remediation_condition': 'remediation_condition',
        'schedule_status': 'schedule_status',
        'severity': 'severity',
        'status': 'status',
        'target_date': 'target_date'
    }

    def __init__(self, artifacts=None, closed_by=None, component=None, contact=None, created_at=None, created_by=None, cve=None, deployments_count=None, id=None, remediation_condition=None, schedule_status=None, severity=None, status=None, target_date=None):  # noqa: E501
        """RemediationListingResponse - a model defined in Swagger"""  # noqa: E501
        self._artifacts = None
        self._closed_by = None
        self._component = None
        self._contact = None
        self._created_at = None
        self._created_by = None
        self._cve = None
        self._deployments_count = None
        self._id = None
        self._remediation_condition = None
        self._schedule_status = None
        self._severity = None
        self._status = None
        self._target_date = None
        self.discriminator = None
        self.artifacts = artifacts
        if closed_by is not None:
            self.closed_by = closed_by
        self.component = component
        if contact is not None:
            self.contact = contact
        self.created_at = created_at
        self.created_by = created_by
        if cve is not None:
            self.cve = cve
        self.deployments_count = deployments_count
        self.id = id
        self.remediation_condition = remediation_condition
        self.schedule_status = schedule_status
        self.severity = severity
        self.status = status
        if target_date is not None:
            self.target_date = target_date

    @property
    def artifacts(self):
        """Gets the artifacts of this RemediationListingResponse.  # noqa: E501

        Total distinct artifacts included in the tracker.  # noqa: E501

        :return: The artifacts of this RemediationListingResponse.  # noqa: E501
        :rtype: int
        """
        return self._artifacts

    @artifacts.setter
    def artifacts(self, artifacts):
        """Sets the artifacts of this RemediationListingResponse.

        Total distinct artifacts included in the tracker.  # noqa: E501

        :param artifacts: The artifacts of this RemediationListingResponse.  # noqa: E501
        :type: int
        """
        if artifacts is None:
            raise ValueError("Invalid value for `artifacts`, must not be `None`")  # noqa: E501

        self._artifacts = artifacts

    @property
    def closed_by(self):
        """Gets the closed_by of this RemediationListingResponse.  # noqa: E501

        If tracker was closed manually , name of the person who closed it   # noqa: E501

        :return: The closed_by of this RemediationListingResponse.  # noqa: E501
        :rtype: str
        """
        return self._closed_by

    @closed_by.setter
    def closed_by(self, closed_by):
        """Sets the closed_by of this RemediationListingResponse.

        If tracker was closed manually , name of the person who closed it   # noqa: E501

        :param closed_by: The closed_by of this RemediationListingResponse.  # noqa: E501
        :type: str
        """

        self._closed_by = closed_by

    @property
    def component(self):
        """Gets the component of this RemediationListingResponse.  # noqa: E501

        Component Name.  # noqa: E501

        :return: The component of this RemediationListingResponse.  # noqa: E501
        :rtype: str
        """
        return self._component

    @component.setter
    def component(self, component):
        """Sets the component of this RemediationListingResponse.

        Component Name.  # noqa: E501

        :param component: The component of this RemediationListingResponse.  # noqa: E501
        :type: str
        """
        if component is None:
            raise ValueError("Invalid value for `component`, must not be `None`")  # noqa: E501

        self._component = component

    @property
    def contact(self):
        """Gets the contact of this RemediationListingResponse.  # noqa: E501


        :return: The contact of this RemediationListingResponse.  # noqa: E501
        :rtype: ContactInfo
        """
        return self._contact

    @contact.setter
    def contact(self, contact):
        """Sets the contact of this RemediationListingResponse.


        :param contact: The contact of this RemediationListingResponse.  # noqa: E501
        :type: ContactInfo
        """

        self._contact = contact

    @property
    def created_at(self):
        """Gets the created_at of this RemediationListingResponse.  # noqa: E501

        Time when tracker was created.  # noqa: E501

        :return: The created_at of this RemediationListingResponse.  # noqa: E501
        :rtype: int
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this RemediationListingResponse.

        Time when tracker was created.  # noqa: E501

        :param created_at: The created_at of this RemediationListingResponse.  # noqa: E501
        :type: int
        """
        if created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this RemediationListingResponse.  # noqa: E501

        Name of the person who created the tracker.  # noqa: E501

        :return: The created_by of this RemediationListingResponse.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this RemediationListingResponse.

        Name of the person who created the tracker.  # noqa: E501

        :param created_by: The created_by of this RemediationListingResponse.  # noqa: E501
        :type: str
        """
        if created_by is None:
            raise ValueError("Invalid value for `created_by`, must not be `None`")  # noqa: E501

        self._created_by = created_by

    @property
    def cve(self):
        """Gets the cve of this RemediationListingResponse.  # noqa: E501

        CVE number.  # noqa: E501

        :return: The cve of this RemediationListingResponse.  # noqa: E501
        :rtype: str
        """
        return self._cve

    @cve.setter
    def cve(self, cve):
        """Sets the cve of this RemediationListingResponse.

        CVE number.  # noqa: E501

        :param cve: The cve of this RemediationListingResponse.  # noqa: E501
        :type: str
        """

        self._cve = cve

    @property
    def deployments_count(self):
        """Gets the deployments_count of this RemediationListingResponse.  # noqa: E501


        :return: The deployments_count of this RemediationListingResponse.  # noqa: E501
        :rtype: DeploymentsCount
        """
        return self._deployments_count

    @deployments_count.setter
    def deployments_count(self, deployments_count):
        """Sets the deployments_count of this RemediationListingResponse.


        :param deployments_count: The deployments_count of this RemediationListingResponse.  # noqa: E501
        :type: DeploymentsCount
        """
        if deployments_count is None:
            raise ValueError("Invalid value for `deployments_count`, must not be `None`")  # noqa: E501

        self._deployments_count = deployments_count

    @property
    def id(self):
        """Gets the id of this RemediationListingResponse.  # noqa: E501

        Tracker Id.  # noqa: E501

        :return: The id of this RemediationListingResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RemediationListingResponse.

        Tracker Id.  # noqa: E501

        :param id: The id of this RemediationListingResponse.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def remediation_condition(self):
        """Gets the remediation_condition of this RemediationListingResponse.  # noqa: E501


        :return: The remediation_condition of this RemediationListingResponse.  # noqa: E501
        :rtype: RemediationCondition
        """
        return self._remediation_condition

    @remediation_condition.setter
    def remediation_condition(self, remediation_condition):
        """Sets the remediation_condition of this RemediationListingResponse.


        :param remediation_condition: The remediation_condition of this RemediationListingResponse.  # noqa: E501
        :type: RemediationCondition
        """
        if remediation_condition is None:
            raise ValueError("Invalid value for `remediation_condition`, must not be `None`")  # noqa: E501

        self._remediation_condition = remediation_condition

    @property
    def schedule_status(self):
        """Gets the schedule_status of this RemediationListingResponse.  # noqa: E501

        This indicates how we are going with schedule of target date.   # noqa: E501

        :return: The schedule_status of this RemediationListingResponse.  # noqa: E501
        :rtype: str
        """
        return self._schedule_status

    @schedule_status.setter
    def schedule_status(self, schedule_status):
        """Sets the schedule_status of this RemediationListingResponse.

        This indicates how we are going with schedule of target date.   # noqa: E501

        :param schedule_status: The schedule_status of this RemediationListingResponse.  # noqa: E501
        :type: str
        """
        if schedule_status is None:
            raise ValueError("Invalid value for `schedule_status`, must not be `None`")  # noqa: E501

        self._schedule_status = schedule_status

    @property
    def severity(self):
        """Gets the severity of this RemediationListingResponse.  # noqa: E501


        :return: The severity of this RemediationListingResponse.  # noqa: E501
        :rtype: VulnerabilitySeverity
        """
        return self._severity

    @severity.setter
    def severity(self, severity):
        """Sets the severity of this RemediationListingResponse.


        :param severity: The severity of this RemediationListingResponse.  # noqa: E501
        :type: VulnerabilitySeverity
        """
        if severity is None:
            raise ValueError("Invalid value for `severity`, must not be `None`")  # noqa: E501

        self._severity = severity

    @property
    def status(self):
        """Gets the status of this RemediationListingResponse.  # noqa: E501


        :return: The status of this RemediationListingResponse.  # noqa: E501
        :rtype: RemediationStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this RemediationListingResponse.


        :param status: The status of this RemediationListingResponse.  # noqa: E501
        :type: RemediationStatus
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def target_date(self):
        """Gets the target_date of this RemediationListingResponse.  # noqa: E501

        Target End Date set by the user.  # noqa: E501

        :return: The target_date of this RemediationListingResponse.  # noqa: E501
        :rtype: str
        """
        return self._target_date

    @target_date.setter
    def target_date(self, target_date):
        """Sets the target_date of this RemediationListingResponse.

        Target End Date set by the user.  # noqa: E501

        :param target_date: The target_date of this RemediationListingResponse.  # noqa: E501
        :type: str
        """

        self._target_date = target_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RemediationListingResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RemediationListingResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
