# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Segment(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created_at': 'int',
        'environment': 'str',
        'excluded': 'list[Target]',
        'identifier': 'str',
        'included': 'list[Target]',
        'modified_at': 'int',
        'name': 'str',
        'rules': 'list[Clause]',
        'serving_rules': 'list[GroupServingRule]',
        'tags': 'list[Tag]',
        'version': 'int'
    }

    attribute_map = {
        'created_at': 'createdAt',
        'environment': 'environment',
        'excluded': 'excluded',
        'identifier': 'identifier',
        'included': 'included',
        'modified_at': 'modifiedAt',
        'name': 'name',
        'rules': 'rules',
        'serving_rules': 'servingRules',
        'tags': 'tags',
        'version': 'version'
    }

    def __init__(self, created_at=None, environment=None, excluded=None, identifier=None, included=None, modified_at=None, name=None, rules=None, serving_rules=None, tags=None, version=None):  # noqa: E501
        """Segment - a model defined in Swagger"""  # noqa: E501
        self._created_at = None
        self._environment = None
        self._excluded = None
        self._identifier = None
        self._included = None
        self._modified_at = None
        self._name = None
        self._rules = None
        self._serving_rules = None
        self._tags = None
        self._version = None
        self.discriminator = None
        if created_at is not None:
            self.created_at = created_at
        if environment is not None:
            self.environment = environment
        if excluded is not None:
            self.excluded = excluded
        self.identifier = identifier
        if included is not None:
            self.included = included
        if modified_at is not None:
            self.modified_at = modified_at
        self.name = name
        if rules is not None:
            self.rules = rules
        if serving_rules is not None:
            self.serving_rules = serving_rules
        if tags is not None:
            self.tags = tags
        if version is not None:
            self.version = version

    @property
    def created_at(self):
        """Gets the created_at of this Segment.  # noqa: E501

        The data and time in milliseconds when the group was created  # noqa: E501

        :return: The created_at of this Segment.  # noqa: E501
        :rtype: int
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Segment.

        The data and time in milliseconds when the group was created  # noqa: E501

        :param created_at: The created_at of this Segment.  # noqa: E501
        :type: int
        """

        self._created_at = created_at

    @property
    def environment(self):
        """Gets the environment of this Segment.  # noqa: E501

        The environment this target group belongs to  # noqa: E501

        :return: The environment of this Segment.  # noqa: E501
        :rtype: str
        """
        return self._environment

    @environment.setter
    def environment(self, environment):
        """Sets the environment of this Segment.

        The environment this target group belongs to  # noqa: E501

        :param environment: The environment of this Segment.  # noqa: E501
        :type: str
        """

        self._environment = environment

    @property
    def excluded(self):
        """Gets the excluded of this Segment.  # noqa: E501

        A list of Targets who are excluded from this target group  # noqa: E501

        :return: The excluded of this Segment.  # noqa: E501
        :rtype: list[Target]
        """
        return self._excluded

    @excluded.setter
    def excluded(self, excluded):
        """Sets the excluded of this Segment.

        A list of Targets who are excluded from this target group  # noqa: E501

        :param excluded: The excluded of this Segment.  # noqa: E501
        :type: list[Target]
        """

        self._excluded = excluded

    @property
    def identifier(self):
        """Gets the identifier of this Segment.  # noqa: E501

        Unique identifier for the target group.  # noqa: E501

        :return: The identifier of this Segment.  # noqa: E501
        :rtype: str
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this Segment.

        Unique identifier for the target group.  # noqa: E501

        :param identifier: The identifier of this Segment.  # noqa: E501
        :type: str
        """
        if identifier is None:
            raise ValueError("Invalid value for `identifier`, must not be `None`")  # noqa: E501

        self._identifier = identifier

    @property
    def included(self):
        """Gets the included of this Segment.  # noqa: E501

        A list of Targets who belong to this target group  # noqa: E501

        :return: The included of this Segment.  # noqa: E501
        :rtype: list[Target]
        """
        return self._included

    @included.setter
    def included(self, included):
        """Sets the included of this Segment.

        A list of Targets who belong to this target group  # noqa: E501

        :param included: The included of this Segment.  # noqa: E501
        :type: list[Target]
        """

        self._included = included

    @property
    def modified_at(self):
        """Gets the modified_at of this Segment.  # noqa: E501

        The data and time in milliseconds when the group was last modified  # noqa: E501

        :return: The modified_at of this Segment.  # noqa: E501
        :rtype: int
        """
        return self._modified_at

    @modified_at.setter
    def modified_at(self, modified_at):
        """Sets the modified_at of this Segment.

        The data and time in milliseconds when the group was last modified  # noqa: E501

        :param modified_at: The modified_at of this Segment.  # noqa: E501
        :type: int
        """

        self._modified_at = modified_at

    @property
    def name(self):
        """Gets the name of this Segment.  # noqa: E501

        Name of the target group.  # noqa: E501

        :return: The name of this Segment.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Segment.

        Name of the target group.  # noqa: E501

        :param name: The name of this Segment.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def rules(self):
        """Gets the rules of this Segment.  # noqa: E501


        :return: The rules of this Segment.  # noqa: E501
        :rtype: list[Clause]
        """
        return self._rules

    @rules.setter
    def rules(self, rules):
        """Sets the rules of this Segment.


        :param rules: The rules of this Segment.  # noqa: E501
        :type: list[Clause]
        """

        self._rules = rules

    @property
    def serving_rules(self):
        """Gets the serving_rules of this Segment.  # noqa: E501

        An array of rules that can cause a user to be included in this segment.  # noqa: E501

        :return: The serving_rules of this Segment.  # noqa: E501
        :rtype: list[GroupServingRule]
        """
        return self._serving_rules

    @serving_rules.setter
    def serving_rules(self, serving_rules):
        """Sets the serving_rules of this Segment.

        An array of rules that can cause a user to be included in this segment.  # noqa: E501

        :param serving_rules: The serving_rules of this Segment.  # noqa: E501
        :type: list[GroupServingRule]
        """

        self._serving_rules = serving_rules

    @property
    def tags(self):
        """Gets the tags of this Segment.  # noqa: E501

        Tags for this target group  # noqa: E501

        :return: The tags of this Segment.  # noqa: E501
        :rtype: list[Tag]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this Segment.

        Tags for this target group  # noqa: E501

        :param tags: The tags of this Segment.  # noqa: E501
        :type: list[Tag]
        """

        self._tags = tags

    @property
    def version(self):
        """Gets the version of this Segment.  # noqa: E501

        The version of this group.  Each time it is modified the version is incremented  # noqa: E501

        :return: The version of this Segment.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Segment.

        The version of this group.  Each time it is modified the version is incremented  # noqa: E501

        :param version: The version of this Segment.  # noqa: E501
        :type: int
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Segment, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Segment):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
