# coding: utf-8

"""
    Harness NextGen Software Delivery Platform API Reference

    The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes. # Introduction     The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.    For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).  ## How it works    The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).  ## Get started    Before you start integrating, get to know our API better by reading the following topics:    * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)   * [Authentication](#section/Introduction/Authentication)   * [Requests and responses](#section/Introduction/Requests-and-Responses)   * [Common Parameters](#section/Introduction/Common-Parameters-Beta)   * [Status Codes](#section/Introduction/Status-Codes)   * [Errors](#tag/Error-Response)   * [Versioning](#section/Introduction/Versioning-Beta)   * [Pagination](/#section/Introduction/Pagination-Beta)    The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.  ## Authentication  To authenticate with the Harness API, you need to:   1. Generate an API token on the Harness Platform.   2. Send the API token you generate in the `x-api-key` header in each request.  ### Generate an API token  To generate an API token, complete the following steps:   1. Go to the [Harness Platform](https://app.harness.io/).   2. On the left-hand navigation, click **My Profile**.   3. Click **+API Key**, enter a name for your key and then click **Save**.   4. Within the API Key tile, click **+Token**.   5. Enter a name for your token and click **Generate Token**. **Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.  ### Send the API token in your requests  Send the token you created in the Harness Platform in the x-api-key header. For example:   `x-api-key: YOUR_API_KEY_HERE`  ## Requests and Responses    The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.  ## Common Parameters [Beta]  | Field Name | Type    | Default | Description    | |------------|---------|---------|----------------| | identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            | | name       | string  | none    | Human-friendly name for the resource.                                                                                       | | org        | string  | none    | Limit to provided org identifiers.                                                                                                                     | | project    | string  | none    | Limit to provided project identifiers.                                                                                                                 | | description| string  | none    | More information about the specific resource.                                                                                    | | tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         | | order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     | | sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. | | limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 | | page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  | | created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               | | updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |   ## Status Codes    Harness uses conventional HTTP status codes to indicate the status of an API request.    Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.    | Error Code  | Description |   |-------------|-------------|   | 200         |     OK      |   | 201         |   Created   |   | 202         |   Accepted  |   | 204         |  No Content |   | 400         | Bad Request |   | 401         | Unauthorized |   | 403         | Forbidden |   | 412         | Precondition Failed |   | 415         | Unsupported Media Type |   | 500         | Server Error |    To view our error response structures, go [here](#tag/Error-Response).  ## Versioning [Beta]  ### Harness Version   The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.  ### Generation   All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.    The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.  ## Pagination [Beta]  We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.  Following are the pagination headers supported in the response bodies of paginated APIs:   1. X-Total-Elements : Indicates the total number of entries in a paginated response.   2. X-Page-Number : Indicates the page number currently returned for a paginated response.   3. X-Page-Size : Indicates the number of entries per page for a paginated response.  For example:    ``` X-Total-Elements : 30 X-Page-Number : 0 X-Page-Size : 10   ```   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: contact@harness.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SLOHealthListView(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'burn_rate': 'float',
        'description': 'str',
        'downtime_status_details': 'DowntimeStatusDetails',
        'environment_identifier': 'str',
        'environment_name': 'str',
        'error_budget_remaining': 'int',
        'error_budget_remaining_percentage': 'float',
        'error_budget_risk': 'str',
        'evaluation_type': 'SLIEvaluationType',
        'health_source_identifier': 'str',
        'health_source_name': 'str',
        'monitored_service_identifier': 'str',
        'monitored_service_name': 'str',
        'name': 'str',
        'no_of_active_alerts': 'int',
        'org_name': 'str',
        'project_name': 'str',
        'project_params': 'ProjectParams',
        'service_identifier': 'str',
        'service_name': 'str',
        'slo_error': 'SLOError',
        'slo_identifier': 'str',
        'slo_target_percentage': 'float',
        'slo_target_type': 'SLOTargetType',
        'slo_type': 'ServiceLevelObjectiveType',
        'tags': 'list[str]',
        'total_error_budget': 'int',
        'user_journey_name': 'str',
        'user_journeys': 'list[UserJourney]'
    }

    attribute_map = {
        'burn_rate': 'burn_rate',
        'description': 'description',
        'downtime_status_details': 'downtime_status_details',
        'environment_identifier': 'environment_identifier',
        'environment_name': 'environment_name',
        'error_budget_remaining': 'error_budget_remaining',
        'error_budget_remaining_percentage': 'error_budget_remaining_percentage',
        'error_budget_risk': 'error_budget_risk',
        'evaluation_type': 'evaluation_type',
        'health_source_identifier': 'health_source_identifier',
        'health_source_name': 'health_source_name',
        'monitored_service_identifier': 'monitored_service_identifier',
        'monitored_service_name': 'monitored_service_name',
        'name': 'name',
        'no_of_active_alerts': 'no_of_active_alerts',
        'org_name': 'org_name',
        'project_name': 'project_name',
        'project_params': 'project_params',
        'service_identifier': 'service_identifier',
        'service_name': 'service_name',
        'slo_error': 'slo_error',
        'slo_identifier': 'slo_identifier',
        'slo_target_percentage': 'slo_target_percentage',
        'slo_target_type': 'slo_target_type',
        'slo_type': 'slo_type',
        'tags': 'tags',
        'total_error_budget': 'total_error_budget',
        'user_journey_name': 'user_journey_name',
        'user_journeys': 'user_journeys'
    }

    def __init__(self, burn_rate=None, description=None, downtime_status_details=None, environment_identifier=None, environment_name=None, error_budget_remaining=None, error_budget_remaining_percentage=None, error_budget_risk=None, evaluation_type=None, health_source_identifier=None, health_source_name=None, monitored_service_identifier=None, monitored_service_name=None, name=None, no_of_active_alerts=None, org_name=None, project_name=None, project_params=None, service_identifier=None, service_name=None, slo_error=None, slo_identifier=None, slo_target_percentage=None, slo_target_type=None, slo_type=None, tags=None, total_error_budget=None, user_journey_name=None, user_journeys=None):  # noqa: E501
        """SLOHealthListView - a model defined in Swagger"""  # noqa: E501
        self._burn_rate = None
        self._description = None
        self._downtime_status_details = None
        self._environment_identifier = None
        self._environment_name = None
        self._error_budget_remaining = None
        self._error_budget_remaining_percentage = None
        self._error_budget_risk = None
        self._evaluation_type = None
        self._health_source_identifier = None
        self._health_source_name = None
        self._monitored_service_identifier = None
        self._monitored_service_name = None
        self._name = None
        self._no_of_active_alerts = None
        self._org_name = None
        self._project_name = None
        self._project_params = None
        self._service_identifier = None
        self._service_name = None
        self._slo_error = None
        self._slo_identifier = None
        self._slo_target_percentage = None
        self._slo_target_type = None
        self._slo_type = None
        self._tags = None
        self._total_error_budget = None
        self._user_journey_name = None
        self._user_journeys = None
        self.discriminator = None
        self.burn_rate = burn_rate
        if description is not None:
            self.description = description
        if downtime_status_details is not None:
            self.downtime_status_details = downtime_status_details
        if environment_identifier is not None:
            self.environment_identifier = environment_identifier
        if environment_name is not None:
            self.environment_name = environment_name
        self.error_budget_remaining = error_budget_remaining
        self.error_budget_remaining_percentage = error_budget_remaining_percentage
        if error_budget_risk is not None:
            self.error_budget_risk = error_budget_risk
        self.evaluation_type = evaluation_type
        if health_source_identifier is not None:
            self.health_source_identifier = health_source_identifier
        if health_source_name is not None:
            self.health_source_name = health_source_name
        if monitored_service_identifier is not None:
            self.monitored_service_identifier = monitored_service_identifier
        if monitored_service_name is not None:
            self.monitored_service_name = monitored_service_name
        self.name = name
        self.no_of_active_alerts = no_of_active_alerts
        if org_name is not None:
            self.org_name = org_name
        if project_name is not None:
            self.project_name = project_name
        self.project_params = project_params
        if service_identifier is not None:
            self.service_identifier = service_identifier
        if service_name is not None:
            self.service_name = service_name
        if slo_error is not None:
            self.slo_error = slo_error
        self.slo_identifier = slo_identifier
        self.slo_target_percentage = slo_target_percentage
        if slo_target_type is not None:
            self.slo_target_type = slo_target_type
        self.slo_type = slo_type
        if tags is not None:
            self.tags = tags
        self.total_error_budget = total_error_budget
        if user_journey_name is not None:
            self.user_journey_name = user_journey_name
        if user_journeys is not None:
            self.user_journeys = user_journeys

    @property
    def burn_rate(self):
        """Gets the burn_rate of this SLOHealthListView.  # noqa: E501

        Burn rate per day of the SLO. The unit is \"Minutes\" if the Evaluation type is Window, for Request based it's \"Request\".  # noqa: E501

        :return: The burn_rate of this SLOHealthListView.  # noqa: E501
        :rtype: float
        """
        return self._burn_rate

    @burn_rate.setter
    def burn_rate(self, burn_rate):
        """Sets the burn_rate of this SLOHealthListView.

        Burn rate per day of the SLO. The unit is \"Minutes\" if the Evaluation type is Window, for Request based it's \"Request\".  # noqa: E501

        :param burn_rate: The burn_rate of this SLOHealthListView.  # noqa: E501
        :type: float
        """
        if burn_rate is None:
            raise ValueError("Invalid value for `burn_rate`, must not be `None`")  # noqa: E501

        self._burn_rate = burn_rate

    @property
    def description(self):
        """Gets the description of this SLOHealthListView.  # noqa: E501

        Description for the SLO.  # noqa: E501

        :return: The description of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this SLOHealthListView.

        Description for the SLO.  # noqa: E501

        :param description: The description of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def downtime_status_details(self):
        """Gets the downtime_status_details of this SLOHealthListView.  # noqa: E501


        :return: The downtime_status_details of this SLOHealthListView.  # noqa: E501
        :rtype: DowntimeStatusDetails
        """
        return self._downtime_status_details

    @downtime_status_details.setter
    def downtime_status_details(self, downtime_status_details):
        """Sets the downtime_status_details of this SLOHealthListView.


        :param downtime_status_details: The downtime_status_details of this SLOHealthListView.  # noqa: E501
        :type: DowntimeStatusDetails
        """

        self._downtime_status_details = downtime_status_details

    @property
    def environment_identifier(self):
        """Gets the environment_identifier of this SLOHealthListView.  # noqa: E501

        Identifier of the Environment to which the SLO is associated.  # noqa: E501

        :return: The environment_identifier of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._environment_identifier

    @environment_identifier.setter
    def environment_identifier(self, environment_identifier):
        """Sets the environment_identifier of this SLOHealthListView.

        Identifier of the Environment to which the SLO is associated.  # noqa: E501

        :param environment_identifier: The environment_identifier of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._environment_identifier = environment_identifier

    @property
    def environment_name(self):
        """Gets the environment_name of this SLOHealthListView.  # noqa: E501

        Name of the Environment to which the SLO is associated.  # noqa: E501

        :return: The environment_name of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._environment_name

    @environment_name.setter
    def environment_name(self, environment_name):
        """Sets the environment_name of this SLOHealthListView.

        Name of the Environment to which the SLO is associated.  # noqa: E501

        :param environment_name: The environment_name of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._environment_name = environment_name

    @property
    def error_budget_remaining(self):
        """Gets the error_budget_remaining of this SLOHealthListView.  # noqa: E501

        Error Budget Remaining of the SLO. The unit is \"Minutes\" if the Evaluation type is Window, for Request based it's \"Request\".  # noqa: E501

        :return: The error_budget_remaining of this SLOHealthListView.  # noqa: E501
        :rtype: int
        """
        return self._error_budget_remaining

    @error_budget_remaining.setter
    def error_budget_remaining(self, error_budget_remaining):
        """Sets the error_budget_remaining of this SLOHealthListView.

        Error Budget Remaining of the SLO. The unit is \"Minutes\" if the Evaluation type is Window, for Request based it's \"Request\".  # noqa: E501

        :param error_budget_remaining: The error_budget_remaining of this SLOHealthListView.  # noqa: E501
        :type: int
        """
        if error_budget_remaining is None:
            raise ValueError("Invalid value for `error_budget_remaining`, must not be `None`")  # noqa: E501

        self._error_budget_remaining = error_budget_remaining

    @property
    def error_budget_remaining_percentage(self):
        """Gets the error_budget_remaining_percentage of this SLOHealthListView.  # noqa: E501

        Error Budget Remaining Percentage of the SLO.  # noqa: E501

        :return: The error_budget_remaining_percentage of this SLOHealthListView.  # noqa: E501
        :rtype: float
        """
        return self._error_budget_remaining_percentage

    @error_budget_remaining_percentage.setter
    def error_budget_remaining_percentage(self, error_budget_remaining_percentage):
        """Sets the error_budget_remaining_percentage of this SLOHealthListView.

        Error Budget Remaining Percentage of the SLO.  # noqa: E501

        :param error_budget_remaining_percentage: The error_budget_remaining_percentage of this SLOHealthListView.  # noqa: E501
        :type: float
        """
        if error_budget_remaining_percentage is None:
            raise ValueError("Invalid value for `error_budget_remaining_percentage`, must not be `None`")  # noqa: E501

        self._error_budget_remaining_percentage = error_budget_remaining_percentage

    @property
    def error_budget_risk(self):
        """Gets the error_budget_risk of this SLOHealthListView.  # noqa: E501

        Error Budget Risk for the SLO. - It's Healthy if Error Budget Remaining Percentage >= 75. - It's Observe if Error Budget Remaining Percentage >= 50 < 75. - It's Need Attention if Error Budget Remaining Percentage >= 25 < 50. - It's Unhealthy if Error Budget Remaining Percentage >= 0 < 25. - It's Exhausted if Error Budget Remaining Percentage < 0.   # noqa: E501

        :return: The error_budget_risk of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._error_budget_risk

    @error_budget_risk.setter
    def error_budget_risk(self, error_budget_risk):
        """Sets the error_budget_risk of this SLOHealthListView.

        Error Budget Risk for the SLO. - It's Healthy if Error Budget Remaining Percentage >= 75. - It's Observe if Error Budget Remaining Percentage >= 50 < 75. - It's Need Attention if Error Budget Remaining Percentage >= 25 < 50. - It's Unhealthy if Error Budget Remaining Percentage >= 0 < 25. - It's Exhausted if Error Budget Remaining Percentage < 0.   # noqa: E501

        :param error_budget_risk: The error_budget_risk of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._error_budget_risk = error_budget_risk

    @property
    def evaluation_type(self):
        """Gets the evaluation_type of this SLOHealthListView.  # noqa: E501


        :return: The evaluation_type of this SLOHealthListView.  # noqa: E501
        :rtype: SLIEvaluationType
        """
        return self._evaluation_type

    @evaluation_type.setter
    def evaluation_type(self, evaluation_type):
        """Sets the evaluation_type of this SLOHealthListView.


        :param evaluation_type: The evaluation_type of this SLOHealthListView.  # noqa: E501
        :type: SLIEvaluationType
        """
        if evaluation_type is None:
            raise ValueError("Invalid value for `evaluation_type`, must not be `None`")  # noqa: E501

        self._evaluation_type = evaluation_type

    @property
    def health_source_identifier(self):
        """Gets the health_source_identifier of this SLOHealthListView.  # noqa: E501

        Identifier of the Health Source to which the SLO is associated.  # noqa: E501

        :return: The health_source_identifier of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._health_source_identifier

    @health_source_identifier.setter
    def health_source_identifier(self, health_source_identifier):
        """Sets the health_source_identifier of this SLOHealthListView.

        Identifier of the Health Source to which the SLO is associated.  # noqa: E501

        :param health_source_identifier: The health_source_identifier of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._health_source_identifier = health_source_identifier

    @property
    def health_source_name(self):
        """Gets the health_source_name of this SLOHealthListView.  # noqa: E501

        Identifier of the Health Source to which the SLO is associated.  # noqa: E501

        :return: The health_source_name of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._health_source_name

    @health_source_name.setter
    def health_source_name(self, health_source_name):
        """Sets the health_source_name of this SLOHealthListView.

        Identifier of the Health Source to which the SLO is associated.  # noqa: E501

        :param health_source_name: The health_source_name of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._health_source_name = health_source_name

    @property
    def monitored_service_identifier(self):
        """Gets the monitored_service_identifier of this SLOHealthListView.  # noqa: E501

        Identifier of the Monitored Service to which the SLO is associated.  # noqa: E501

        :return: The monitored_service_identifier of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._monitored_service_identifier

    @monitored_service_identifier.setter
    def monitored_service_identifier(self, monitored_service_identifier):
        """Sets the monitored_service_identifier of this SLOHealthListView.

        Identifier of the Monitored Service to which the SLO is associated.  # noqa: E501

        :param monitored_service_identifier: The monitored_service_identifier of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._monitored_service_identifier = monitored_service_identifier

    @property
    def monitored_service_name(self):
        """Gets the monitored_service_name of this SLOHealthListView.  # noqa: E501

        Name of the Monitored Service to which the SLO is associated.  # noqa: E501

        :return: The monitored_service_name of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._monitored_service_name

    @monitored_service_name.setter
    def monitored_service_name(self, monitored_service_name):
        """Sets the monitored_service_name of this SLOHealthListView.

        Name of the Monitored Service to which the SLO is associated.  # noqa: E501

        :param monitored_service_name: The monitored_service_name of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._monitored_service_name = monitored_service_name

    @property
    def name(self):
        """Gets the name of this SLOHealthListView.  # noqa: E501

        Name of the SLO.  # noqa: E501

        :return: The name of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SLOHealthListView.

        Name of the SLO.  # noqa: E501

        :param name: The name of this SLOHealthListView.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def no_of_active_alerts(self):
        """Gets the no_of_active_alerts of this SLOHealthListView.  # noqa: E501

        Number of Notification Rules defined for the SLO.  # noqa: E501

        :return: The no_of_active_alerts of this SLOHealthListView.  # noqa: E501
        :rtype: int
        """
        return self._no_of_active_alerts

    @no_of_active_alerts.setter
    def no_of_active_alerts(self, no_of_active_alerts):
        """Sets the no_of_active_alerts of this SLOHealthListView.

        Number of Notification Rules defined for the SLO.  # noqa: E501

        :param no_of_active_alerts: The no_of_active_alerts of this SLOHealthListView.  # noqa: E501
        :type: int
        """
        if no_of_active_alerts is None:
            raise ValueError("Invalid value for `no_of_active_alerts`, must not be `None`")  # noqa: E501

        self._no_of_active_alerts = no_of_active_alerts

    @property
    def org_name(self):
        """Gets the org_name of this SLOHealthListView.  # noqa: E501

        Organization Name to which the SLO belongs.  # noqa: E501

        :return: The org_name of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._org_name

    @org_name.setter
    def org_name(self, org_name):
        """Sets the org_name of this SLOHealthListView.

        Organization Name to which the SLO belongs.  # noqa: E501

        :param org_name: The org_name of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._org_name = org_name

    @property
    def project_name(self):
        """Gets the project_name of this SLOHealthListView.  # noqa: E501

        Project Name to which the SLO belongs.  # noqa: E501

        :return: The project_name of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._project_name

    @project_name.setter
    def project_name(self, project_name):
        """Sets the project_name of this SLOHealthListView.

        Project Name to which the SLO belongs.  # noqa: E501

        :param project_name: The project_name of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._project_name = project_name

    @property
    def project_params(self):
        """Gets the project_params of this SLOHealthListView.  # noqa: E501


        :return: The project_params of this SLOHealthListView.  # noqa: E501
        :rtype: ProjectParams
        """
        return self._project_params

    @project_params.setter
    def project_params(self, project_params):
        """Sets the project_params of this SLOHealthListView.


        :param project_params: The project_params of this SLOHealthListView.  # noqa: E501
        :type: ProjectParams
        """
        if project_params is None:
            raise ValueError("Invalid value for `project_params`, must not be `None`")  # noqa: E501

        self._project_params = project_params

    @property
    def service_identifier(self):
        """Gets the service_identifier of this SLOHealthListView.  # noqa: E501

        Identifier of the Service to which the SLO is associated.  # noqa: E501

        :return: The service_identifier of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._service_identifier

    @service_identifier.setter
    def service_identifier(self, service_identifier):
        """Sets the service_identifier of this SLOHealthListView.

        Identifier of the Service to which the SLO is associated.  # noqa: E501

        :param service_identifier: The service_identifier of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._service_identifier = service_identifier

    @property
    def service_name(self):
        """Gets the service_name of this SLOHealthListView.  # noqa: E501

        Name of the Service to which the SLO is associated.  # noqa: E501

        :return: The service_name of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._service_name

    @service_name.setter
    def service_name(self, service_name):
        """Sets the service_name of this SLOHealthListView.

        Name of the Service to which the SLO is associated.  # noqa: E501

        :param service_name: The service_name of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._service_name = service_name

    @property
    def slo_error(self):
        """Gets the slo_error of this SLOHealthListView.  # noqa: E501


        :return: The slo_error of this SLOHealthListView.  # noqa: E501
        :rtype: SLOError
        """
        return self._slo_error

    @slo_error.setter
    def slo_error(self, slo_error):
        """Sets the slo_error of this SLOHealthListView.


        :param slo_error: The slo_error of this SLOHealthListView.  # noqa: E501
        :type: SLOError
        """

        self._slo_error = slo_error

    @property
    def slo_identifier(self):
        """Gets the slo_identifier of this SLOHealthListView.  # noqa: E501

        Identifier of the SLO.  # noqa: E501

        :return: The slo_identifier of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._slo_identifier

    @slo_identifier.setter
    def slo_identifier(self, slo_identifier):
        """Sets the slo_identifier of this SLOHealthListView.

        Identifier of the SLO.  # noqa: E501

        :param slo_identifier: The slo_identifier of this SLOHealthListView.  # noqa: E501
        :type: str
        """
        if slo_identifier is None:
            raise ValueError("Invalid value for `slo_identifier`, must not be `None`")  # noqa: E501

        self._slo_identifier = slo_identifier

    @property
    def slo_target_percentage(self):
        """Gets the slo_target_percentage of this SLOHealthListView.  # noqa: E501

        Target Percentage of the SLO defined by the user.  # noqa: E501

        :return: The slo_target_percentage of this SLOHealthListView.  # noqa: E501
        :rtype: float
        """
        return self._slo_target_percentage

    @slo_target_percentage.setter
    def slo_target_percentage(self, slo_target_percentage):
        """Sets the slo_target_percentage of this SLOHealthListView.

        Target Percentage of the SLO defined by the user.  # noqa: E501

        :param slo_target_percentage: The slo_target_percentage of this SLOHealthListView.  # noqa: E501
        :type: float
        """
        if slo_target_percentage is None:
            raise ValueError("Invalid value for `slo_target_percentage`, must not be `None`")  # noqa: E501

        self._slo_target_percentage = slo_target_percentage

    @property
    def slo_target_type(self):
        """Gets the slo_target_type of this SLOHealthListView.  # noqa: E501


        :return: The slo_target_type of this SLOHealthListView.  # noqa: E501
        :rtype: SLOTargetType
        """
        return self._slo_target_type

    @slo_target_type.setter
    def slo_target_type(self, slo_target_type):
        """Sets the slo_target_type of this SLOHealthListView.


        :param slo_target_type: The slo_target_type of this SLOHealthListView.  # noqa: E501
        :type: SLOTargetType
        """

        self._slo_target_type = slo_target_type

    @property
    def slo_type(self):
        """Gets the slo_type of this SLOHealthListView.  # noqa: E501


        :return: The slo_type of this SLOHealthListView.  # noqa: E501
        :rtype: ServiceLevelObjectiveType
        """
        return self._slo_type

    @slo_type.setter
    def slo_type(self, slo_type):
        """Sets the slo_type of this SLOHealthListView.


        :param slo_type: The slo_type of this SLOHealthListView.  # noqa: E501
        :type: ServiceLevelObjectiveType
        """
        if slo_type is None:
            raise ValueError("Invalid value for `slo_type`, must not be `None`")  # noqa: E501

        self._slo_type = slo_type

    @property
    def tags(self):
        """Gets the tags of this SLOHealthListView.  # noqa: E501

        List of tags for SLO.  # noqa: E501

        :return: The tags of this SLOHealthListView.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this SLOHealthListView.

        List of tags for SLO.  # noqa: E501

        :param tags: The tags of this SLOHealthListView.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def total_error_budget(self):
        """Gets the total_error_budget of this SLOHealthListView.  # noqa: E501

        Total Error Budget of the SLO. The unit is \"Minutes\" if the Evaluation type is Window, for Request based it's \"Request\".  # noqa: E501

        :return: The total_error_budget of this SLOHealthListView.  # noqa: E501
        :rtype: int
        """
        return self._total_error_budget

    @total_error_budget.setter
    def total_error_budget(self, total_error_budget):
        """Sets the total_error_budget of this SLOHealthListView.

        Total Error Budget of the SLO. The unit is \"Minutes\" if the Evaluation type is Window, for Request based it's \"Request\".  # noqa: E501

        :param total_error_budget: The total_error_budget of this SLOHealthListView.  # noqa: E501
        :type: int
        """
        if total_error_budget is None:
            raise ValueError("Invalid value for `total_error_budget`, must not be `None`")  # noqa: E501

        self._total_error_budget = total_error_budget

    @property
    def user_journey_name(self):
        """Gets the user_journey_name of this SLOHealthListView.  # noqa: E501

        Name of the first User Journey for the SLO.  # noqa: E501

        :return: The user_journey_name of this SLOHealthListView.  # noqa: E501
        :rtype: str
        """
        return self._user_journey_name

    @user_journey_name.setter
    def user_journey_name(self, user_journey_name):
        """Sets the user_journey_name of this SLOHealthListView.

        Name of the first User Journey for the SLO.  # noqa: E501

        :param user_journey_name: The user_journey_name of this SLOHealthListView.  # noqa: E501
        :type: str
        """

        self._user_journey_name = user_journey_name

    @property
    def user_journeys(self):
        """Gets the user_journeys of this SLOHealthListView.  # noqa: E501


        :return: The user_journeys of this SLOHealthListView.  # noqa: E501
        :rtype: list[UserJourney]
        """
        return self._user_journeys

    @user_journeys.setter
    def user_journeys(self, user_journeys):
        """Sets the user_journeys of this SLOHealthListView.


        :param user_journeys: The user_journeys of this SLOHealthListView.  # noqa: E501
        :type: list[UserJourney]
        """

        self._user_journeys = user_journeys

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SLOHealthListView, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SLOHealthListView):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
